# Copyright (c) 2008-2010, Alexis Royer, http://alexis.royer.free.fr/Watch
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#     * Neither the name of the Watch project nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

.DEFAULT_GOAL = default
.PHONY: abc-deal.default
abc-deal.default: $(.DEFAULT_GOAL)


include _vars.mak

# Rules
.PHONY: default
default:
	$(call MkDispatch,watch.mak,)
	$(call MkDispatch,$(WATCH_DIR)/samples/abc-deal/Makefile,)

.PHONY: interactive
interactive:
	$(call MkDispatch,watch.mak,)
	$(call MkDispatch,$(WATCH_DIR)/samples/abc-deal/Makefile,interactive)

.PHONY: deps
deps: ;

.PHONY: clean
clean:
	$(call MkDispatch,watch.mak,clean)
	$(call MkDispatch,$(WATCH_DIR)/samples/abc-deal/Makefile,clean)

# Debug and help
include _help.mak

.PHONY: $(WATCH_DIR)/build/make/abc-deal.help
help: $(WATCH_DIR)/build/make/abc-deal.help
$(WATCH_DIR)/build/make/abc-deal.help: ;
	$(call PrintHelp, default,      Launch the sample)
	$(call PrintHelp, interactive,  Launch the sample in interactive mode)
	$(call PrintHelp, clean,        Clean up the sample)
