# Copyright (c) 2008-2010, Alexis Royer, http://alexis.royer.free.fr/Watch
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#     * Neither the name of the Watch project nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


.DEFAULT_GOAL = default
.PHONY: unit.default
unit.default: $(.DEFAULT_GOAL)


include _vars.mak

# Rules
.PHONY: default
default: unit.dep unit.run ;

.PHONY: unit.dep
unit.dep:
	$(call MkDispatch,watch.mak,)

.PHONY: unit.run
unit.run:
	$(call MkDispatch,$(WATCH_DIR)/tests/unit/Makefile,)

.PHONY: deps
deps: ;

.PHONY: clean
clean:
	$(call MkDispatch,watch.mak,clean)
	$(call MkDispatch,$(WATCH_DIR)/tests/unit/Makefile,clean)

# Debug and help
include _help.mak

.PHONY: $(WATCH_DIR)/build/make/unit.help
help: $(WATCH_DIR)/build/make/unit.help
$(WATCH_DIR)/build/make/unit.help:
	$(call PrintHelp, default, Build and run the test)
	$(call PrintHelp, clean, Cleanup the test (and sub-projects))
