/*
    Copyright (c) 2008-2010, Alexis Royer, http://alexis.royer.free.fr/Watch

    All rights reserved.

    Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

        * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
        * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
        * Neither the name of the Watch project nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package watch;


class XmlInput_1_0 {
    void xml2model(java.io.File J_XmlFile, watch.Watch W_Watch) throws java.lang.Exception {
        javax.xml.parsers.DocumentBuilderFactory xml_Factory = javax.xml.parsers.DocumentBuilderFactory.newInstance();
        javax.xml.parsers.DocumentBuilder xml_Parser = xml_Factory.newDocumentBuilder();
        org.w3c.dom.Document xml_Doc = xml_Parser.parse(new java.io.FileInputStream(J_XmlFile));
        org.w3c.dom.Node xml_CurrentNodeid4488367 = xml_Doc.getFirstChild();
        Xml2Model_T_WatchNode(xml_CurrentNodeid4488367, W_Watch);
    }

    void Xml2Model_T_WatchNode(org.w3c.dom.Node xml_FocusNodeid4486833, watch.Watch W_Watch) {
        Trace.println("Xml2Model_T_WatchNode()");
        org.w3c.dom.Node xml_CurrentNodeid4486833 = xml_FocusNodeid4486833;

        for (int i_Attrid4486833 = 0; i_Attrid4486833 < xml_FocusNodeid4486833.getAttributes().getLength(); i_Attrid4486833 ++) {
            xml_CurrentNodeid4486833 = xml_FocusNodeid4486833.getAttributes().item(i_Attrid4486833);
            Trace.println("found attribute '" + xml_CurrentNodeid4486833.getNodeName() + "'");
            if (false) {
            } else if (xml_CurrentNodeid4486833.getNodeName().equals("version")) {
                if (xml_CurrentNodeid4486833.getTextContent().equals("1.0")) {
                }
            } else if (xml_CurrentNodeid4486833.getNodeName().equals("project")) {
                W_Watch.projectName(xml_CurrentNodeid4486833.getTextContent());
            } else if (xml_CurrentNodeid4486833.getNodeName().equals("locale")) {
                if (xml_CurrentNodeid4486833.getTextContent().equals("chinese")) {
                    W_Watch.locale("chinese");
                }
                if (xml_CurrentNodeid4486833.getTextContent().equals("english")) {
                    W_Watch.locale("english");
                }
                if (xml_CurrentNodeid4486833.getTextContent().equals("french")) {
                    W_Watch.locale("french");
                }
                if (xml_CurrentNodeid4486833.getTextContent().equals("german")) {
                    W_Watch.locale("german");
                }
                if (xml_CurrentNodeid4486833.getTextContent().equals("italian")) {
                    W_Watch.locale("italian");
                }
                if (xml_CurrentNodeid4486833.getTextContent().equals("japanese")) {
                    W_Watch.locale("japanese");
                }
            }
            xml_CurrentNodeid4486833 = xml_FocusNodeid4486833;
        }



        for (int i_Childid4486833 = 0; i_Childid4486833 < xml_FocusNodeid4486833.getChildNodes().getLength(); i_Childid4486833 ++) {
            xml_CurrentNodeid4486833 = xml_FocusNodeid4486833.getChildNodes().item(i_Childid4486833);
            if (xml_CurrentNodeid4486833.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
            if (false) {
            } else if (xml_CurrentNodeid4486833.getNodeName().equals("tasks")) {
                Xml2Model_T_Tasks(xml_CurrentNodeid4486833, W_Watch);
            } else if (xml_CurrentNodeid4486833.getNodeName().equals("imputations")) {
                String j_UserName = null;
                Xml2Model_T_Imputations(xml_CurrentNodeid4486833, W_Watch, j_UserName);
            } else if (xml_CurrentNodeid4486833.getNodeName().equals("revisions")) {
                watch.Date w_Date = null;
                Xml2Model_T_Revisions(xml_CurrentNodeid4486833, W_Watch, w_Date);
            }
            xml_CurrentNodeid4486833 = xml_FocusNodeid4486833;
        }

        Trace.println("Xml2Model_T_WatchNode() ->");
    }

    void Xml2Model_T_Tasks(org.w3c.dom.Node xml_FocusNodeid4489148, watch.Watch W_Watch) {
        Trace.println("Xml2Model_T_Tasks()");
        org.w3c.dom.Node xml_CurrentNodeid4489148 = xml_FocusNodeid4489148;

        for (int i_Attrid4489148 = 0; i_Attrid4489148 < xml_FocusNodeid4489148.getAttributes().getLength(); i_Attrid4489148 ++) {
            xml_CurrentNodeid4489148 = xml_FocusNodeid4489148.getAttributes().item(i_Attrid4489148);
            Trace.println("found attribute '" + xml_CurrentNodeid4489148.getNodeName() + "'");
            if (false) {
            }
            xml_CurrentNodeid4489148 = xml_FocusNodeid4489148;
        }



        for (int i_Childid4489148 = 0; i_Childid4489148 < xml_FocusNodeid4489148.getChildNodes().getLength(); i_Childid4489148 ++) {
            xml_CurrentNodeid4489148 = xml_FocusNodeid4489148.getChildNodes().item(i_Childid4489148);
            if (xml_CurrentNodeid4489148.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
            if (false) {
            } else if (xml_CurrentNodeid4489148.getNodeName().equals("task")) {
                watch.Task w_MainTask = null;
                Xml2Model_T_Task(xml_CurrentNodeid4489148, W_Watch, w_MainTask);
            }
            xml_CurrentNodeid4489148 = xml_FocusNodeid4489148;
        }

        Trace.println("Xml2Model_T_Tasks() ->");
    }

    void Xml2Model_T_Task(org.w3c.dom.Node xml_FocusNodeid4488742, watch.Watch W_Watch, watch.Task W_Task) {
        Trace.println("Xml2Model_T_Task()");
        org.w3c.dom.Node xml_CurrentNodeid4488742 = xml_FocusNodeid4488742;
        
            String j_TaskId = null;
            String j_ReferenceStartDate = null;
            double d_Reference = -1;
            double d_ReferenceRisks = 0;
            double d_ReferenceOpportunities = 0;
            String j_PlannedStartDate = null;
            String j_PlannedEndDate = null;
            int e_SchedulingMode = watch.Task.SCHEDULING_NONE;
            boolean b_IsGroup = (new Integer(xpath(xml_CurrentNodeid4488742, "count(./task)")) > 0);
        

        for (int i_Attrid4488742 = 0; i_Attrid4488742 < xml_FocusNodeid4488742.getAttributes().getLength(); i_Attrid4488742 ++) {
            xml_CurrentNodeid4488742 = xml_FocusNodeid4488742.getAttributes().item(i_Attrid4488742);
            Trace.println("found attribute '" + xml_CurrentNodeid4488742.getNodeName() + "'");
            if (false) {
            } else if (xml_CurrentNodeid4488742.getNodeName().equals("id")) {
                j_TaskId = xml_CurrentNodeid4488742.getTextContent();
            } else if (xml_CurrentNodeid4488742.getNodeName().equals("time")) {
                d_Reference = new Double(xml_CurrentNodeid4488742.getTextContent());
            } else if (xml_CurrentNodeid4488742.getNodeName().equals("value")) {
                d_Reference = new Double(xml_CurrentNodeid4488742.getTextContent());
            } else if (xml_CurrentNodeid4488742.getNodeName().equals("risks")) {
                d_ReferenceRisks = new Double(xml_CurrentNodeid4488742.getTextContent());
            } else if (xml_CurrentNodeid4488742.getNodeName().equals("opportunities")) {
                d_ReferenceOpportunities = new Double(xml_CurrentNodeid4488742.getTextContent());
            } else if (xml_CurrentNodeid4488742.getNodeName().equals("start-date")) {
                j_ReferenceStartDate = xml_CurrentNodeid4488742.getTextContent();
            } else if (xml_CurrentNodeid4488742.getNodeName().equals("plan-start")) {
                j_PlannedStartDate = xml_CurrentNodeid4488742.getTextContent();
            } else if (xml_CurrentNodeid4488742.getNodeName().equals("plan-end")) {
                j_PlannedEndDate = xml_CurrentNodeid4488742.getTextContent();
            } else if (xml_CurrentNodeid4488742.getNodeName().equals("plan-evm")) {
                if (xml_CurrentNodeid4488742.getTextContent().equals("at-end")) {
                    e_SchedulingMode = watch.Task.SCHEDULING_AT_END;
                }
                if (xml_CurrentNodeid4488742.getTextContent().equals("linear")) {
                    e_SchedulingMode = watch.Task.SCHEDULING_LINEAR;
                }
            }
            xml_CurrentNodeid4488742 = xml_FocusNodeid4488742;
        }

        
            if (b_IsGroup) {
                W_Watch.beginTaskGroup(j_TaskId, j_ReferenceStartDate);
            } else {
                W_Watch.singleTask(
                    j_TaskId,
                    j_ReferenceStartDate, d_Reference, d_ReferenceRisks, d_ReferenceOpportunities,
                    j_PlannedStartDate, j_PlannedEndDate, e_SchedulingMode);
            }
        


        for (int i_Childid4488742 = 0; i_Childid4488742 < xml_FocusNodeid4488742.getChildNodes().getLength(); i_Childid4488742 ++) {
            xml_CurrentNodeid4488742 = xml_FocusNodeid4488742.getChildNodes().item(i_Childid4488742);
            if (xml_CurrentNodeid4488742.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
            if (false) {
            } else if (xml_CurrentNodeid4488742.getNodeName().equals("comment")) {
                W_Watch.comment(xml_CurrentNodeid4488742.getTextContent());
            } else if (xml_CurrentNodeid4488742.getNodeName().equals("task")) {
                watch.Task w_SubTask = null;
                Xml2Model_T_Task(xml_CurrentNodeid4488742, W_Watch, w_SubTask);
            }
            xml_CurrentNodeid4488742 = xml_FocusNodeid4488742;
        }
        
            if (b_IsGroup) {
                W_Watch.endTaskGroup();
            }
        

        Trace.println("Xml2Model_T_Task() ->");
    }

    void Xml2Model_T_Imputations(org.w3c.dom.Node xml_FocusNodeid4498741, watch.Watch W_Watch, String J_UserName) {
        Trace.println("Xml2Model_T_Imputations()");
        org.w3c.dom.Node xml_CurrentNodeid4498741 = xml_FocusNodeid4498741;

        for (int i_Attrid4498741 = 0; i_Attrid4498741 < xml_FocusNodeid4498741.getAttributes().getLength(); i_Attrid4498741 ++) {
            xml_CurrentNodeid4498741 = xml_FocusNodeid4498741.getAttributes().item(i_Attrid4498741);
            Trace.println("found attribute '" + xml_CurrentNodeid4498741.getNodeName() + "'");
            if (false) {
            } else if (xml_CurrentNodeid4498741.getNodeName().equals("user")) {
                W_Watch.setCurrentUser(xml_CurrentNodeid4498741.getTextContent());
            }
            xml_CurrentNodeid4498741 = xml_FocusNodeid4498741;
        }



        for (int i_Childid4498741 = 0; i_Childid4498741 < xml_FocusNodeid4498741.getChildNodes().getLength(); i_Childid4498741 ++) {
            xml_CurrentNodeid4498741 = xml_FocusNodeid4498741.getChildNodes().item(i_Childid4498741);
            if (xml_CurrentNodeid4498741.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
            if (false) {
            } else if (xml_CurrentNodeid4498741.getNodeName().equals("day")) {
                watch.Date w_Date = null;
                Xml2Model_T_ImputationDay(xml_CurrentNodeid4498741, W_Watch, J_UserName, w_Date);
            }
            xml_CurrentNodeid4498741 = xml_FocusNodeid4498741;
        }

        Trace.println("Xml2Model_T_Imputations() ->");
    }

    void Xml2Model_T_ImputationDay(org.w3c.dom.Node xml_FocusNodeid4495461, watch.Watch W_Watch, String J_UserName, watch.Date W_Date) {
        Trace.println("Xml2Model_T_ImputationDay()");
        org.w3c.dom.Node xml_CurrentNodeid4495461 = xml_FocusNodeid4495461;
        String j_ImputationDate = null;

        for (int i_Attrid4495461 = 0; i_Attrid4495461 < xml_FocusNodeid4495461.getAttributes().getLength(); i_Attrid4495461 ++) {
            xml_CurrentNodeid4495461 = xml_FocusNodeid4495461.getAttributes().item(i_Attrid4495461);
            Trace.println("found attribute '" + xml_CurrentNodeid4495461.getNodeName() + "'");
            if (false) {
            } else if (xml_CurrentNodeid4495461.getNodeName().equals("date")) {
                j_ImputationDate = xml_CurrentNodeid4495461.getTextContent();
            }
            xml_CurrentNodeid4495461 = xml_FocusNodeid4495461;
        }



        for (int i_Childid4495461 = 0; i_Childid4495461 < xml_FocusNodeid4495461.getChildNodes().getLength(); i_Childid4495461 ++) {
            xml_CurrentNodeid4495461 = xml_FocusNodeid4495461.getChildNodes().item(i_Childid4495461);
            if (xml_CurrentNodeid4495461.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
            if (false) {
            } else if (xml_CurrentNodeid4495461.getNodeName().equals("imputation")) {
                Imputation w_Imputation = null;
                Xml2Model_T_Imputation(xml_CurrentNodeid4495461, W_Watch, j_ImputationDate, w_Imputation);
            }
            xml_CurrentNodeid4495461 = xml_FocusNodeid4495461;
        }

        Trace.println("Xml2Model_T_ImputationDay() ->");
    }

    void Xml2Model_T_Imputation(org.w3c.dom.Node xml_FocusNodeid4490881, watch.Watch W_Watch, String J_ImputationDate, Imputation W_Imputation) {
        Trace.println("Xml2Model_T_Imputation()");
        org.w3c.dom.Node xml_CurrentNodeid4490881 = xml_FocusNodeid4490881;
        
            String j_TaskId = null;
            double d_Value = 0.0;
        

        for (int i_Attrid4490881 = 0; i_Attrid4490881 < xml_FocusNodeid4490881.getAttributes().getLength(); i_Attrid4490881 ++) {
            xml_CurrentNodeid4490881 = xml_FocusNodeid4490881.getAttributes().item(i_Attrid4490881);
            Trace.println("found attribute '" + xml_CurrentNodeid4490881.getNodeName() + "'");
            if (false) {
            } else if (xml_CurrentNodeid4490881.getNodeName().equals("task")) {
                j_TaskId = xml_CurrentNodeid4490881.getTextContent();
            } else if (xml_CurrentNodeid4490881.getNodeName().equals("time")) {
                d_Value = new Double(xml_CurrentNodeid4490881.getTextContent());
            } else if (xml_CurrentNodeid4490881.getNodeName().equals("value")) {
                d_Value = new Double(xml_CurrentNodeid4490881.getTextContent());
            }
            xml_CurrentNodeid4490881 = xml_FocusNodeid4490881;
        }

        
            W_Watch.imputation(j_TaskId, J_ImputationDate, d_Value);
        


        for (int i_Childid4490881 = 0; i_Childid4490881 < xml_FocusNodeid4490881.getChildNodes().getLength(); i_Childid4490881 ++) {
            xml_CurrentNodeid4490881 = xml_FocusNodeid4490881.getChildNodes().item(i_Childid4490881);
            if (xml_CurrentNodeid4490881.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
            if (false) {
            } else if (xml_CurrentNodeid4490881.getNodeName().equals("comment")) {
                W_Watch.comment(xml_CurrentNodeid4490881.getTextContent());
            }
            xml_CurrentNodeid4490881 = xml_FocusNodeid4490881;
        }

        Trace.println("Xml2Model_T_Imputation() ->");
    }

    void Xml2Model_T_Revisions(org.w3c.dom.Node xml_FocusNodeid4489913, watch.Watch W_Watch, watch.Date W_Date) {
        Trace.println("Xml2Model_T_Revisions()");
        org.w3c.dom.Node xml_CurrentNodeid4489913 = xml_FocusNodeid4489913;

        for (int i_Attrid4489913 = 0; i_Attrid4489913 < xml_FocusNodeid4489913.getAttributes().getLength(); i_Attrid4489913 ++) {
            xml_CurrentNodeid4489913 = xml_FocusNodeid4489913.getAttributes().item(i_Attrid4489913);
            Trace.println("found attribute '" + xml_CurrentNodeid4489913.getNodeName() + "'");
            if (false) {
            } else if (xml_CurrentNodeid4489913.getNodeName().equals("date")) {
                W_Watch.setCurrentRevisionDate(xml_CurrentNodeid4489913.getTextContent());
            }
            xml_CurrentNodeid4489913 = xml_FocusNodeid4489913;
        }



        for (int i_Childid4489913 = 0; i_Childid4489913 < xml_FocusNodeid4489913.getChildNodes().getLength(); i_Childid4489913 ++) {
            xml_CurrentNodeid4489913 = xml_FocusNodeid4489913.getChildNodes().item(i_Childid4489913);
            if (xml_CurrentNodeid4489913.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
            Revision w_Revision = null;
            if (false) {
            } else if (xml_CurrentNodeid4489913.getNodeName().equals("revision")) {
                Xml2Model_T_Revision(xml_CurrentNodeid4489913, W_Watch, w_Revision);
            } else if (xml_CurrentNodeid4489913.getNodeName().equals("lock")) {
                Xml2Model_T_Lock(xml_CurrentNodeid4489913, W_Watch, w_Revision);
            }
            xml_CurrentNodeid4489913 = xml_FocusNodeid4489913;
        }
        W_Watch.setCurrentRevisionDate(null);

        Trace.println("Xml2Model_T_Revisions() ->");
    }

    void Xml2Model_T_Revision(org.w3c.dom.Node xml_FocusNodeid4489060, watch.Watch W_Watch, Revision W_Revision) {
        Trace.println("Xml2Model_T_Revision()");
        org.w3c.dom.Node xml_CurrentNodeid4489060 = xml_FocusNodeid4489060;
        
            String j_TaskId = null;
            String j_RevisionDate = null;
            double d_Value = -1;
            double d_Risks = -1;
            double d_Opportunities = -1;
            double d_Earned = -1;
        

        for (int i_Attrid4489060 = 0; i_Attrid4489060 < xml_FocusNodeid4489060.getAttributes().getLength(); i_Attrid4489060 ++) {
            xml_CurrentNodeid4489060 = xml_FocusNodeid4489060.getAttributes().item(i_Attrid4489060);
            Trace.println("found attribute '" + xml_CurrentNodeid4489060.getNodeName() + "'");
            if (false) {
            } else if (xml_CurrentNodeid4489060.getNodeName().equals("task")) {
                j_TaskId = xml_CurrentNodeid4489060.getTextContent();
            } else if (xml_CurrentNodeid4489060.getNodeName().equals("date")) {
                j_RevisionDate = xml_CurrentNodeid4489060.getTextContent();
            } else if (xml_CurrentNodeid4489060.getNodeName().equals("time")) {
                d_Value = new Double(xml_CurrentNodeid4489060.getTextContent());
            } else if (xml_CurrentNodeid4489060.getNodeName().equals("value")) {
                d_Value = new Double(xml_CurrentNodeid4489060.getTextContent());
            } else if (xml_CurrentNodeid4489060.getNodeName().equals("risks")) {
                d_Risks = new Double(xml_CurrentNodeid4489060.getTextContent());
            } else if (xml_CurrentNodeid4489060.getNodeName().equals("opportunities")) {
                d_Opportunities = new Double(xml_CurrentNodeid4489060.getTextContent());
            } else if (xml_CurrentNodeid4489060.getNodeName().equals("earned")) {
                d_Earned = new Double(xml_CurrentNodeid4489060.getTextContent());
            }
            xml_CurrentNodeid4489060 = xml_FocusNodeid4489060;
        }

        
            W_Watch.revision(j_TaskId, j_RevisionDate, d_Value, d_Risks, d_Opportunities, d_Earned);
        


        for (int i_Childid4489060 = 0; i_Childid4489060 < xml_FocusNodeid4489060.getChildNodes().getLength(); i_Childid4489060 ++) {
            xml_CurrentNodeid4489060 = xml_FocusNodeid4489060.getChildNodes().item(i_Childid4489060);
            if (xml_CurrentNodeid4489060.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
            if (false) {
            } else if (xml_CurrentNodeid4489060.getNodeName().equals("comment")) {
                W_Watch.comment(xml_CurrentNodeid4489060.getTextContent());
            }
            xml_CurrentNodeid4489060 = xml_FocusNodeid4489060;
        }

        Trace.println("Xml2Model_T_Revision() ->");
    }

    void Xml2Model_T_Lock(org.w3c.dom.Node xml_FocusNodeid4487363, watch.Watch W_Watch, Revision W_Revision) {
        Trace.println("Xml2Model_T_Lock()");
        org.w3c.dom.Node xml_CurrentNodeid4487363 = xml_FocusNodeid4487363;
        
            String j_TaskId = null;
            String j_RevisionDate = null;
        

        for (int i_Attrid4487363 = 0; i_Attrid4487363 < xml_FocusNodeid4487363.getAttributes().getLength(); i_Attrid4487363 ++) {
            xml_CurrentNodeid4487363 = xml_FocusNodeid4487363.getAttributes().item(i_Attrid4487363);
            Trace.println("found attribute '" + xml_CurrentNodeid4487363.getNodeName() + "'");
            if (false) {
            } else if (xml_CurrentNodeid4487363.getNodeName().equals("task")) {
                j_TaskId = xml_CurrentNodeid4487363.getTextContent();
            } else if (xml_CurrentNodeid4487363.getNodeName().equals("date")) {
                j_RevisionDate = xml_CurrentNodeid4487363.getTextContent();
            }
            xml_CurrentNodeid4487363 = xml_FocusNodeid4487363;
        }

        
            W_Watch.lock(j_TaskId, j_RevisionDate);
        


        for (int i_Childid4487363 = 0; i_Childid4487363 < xml_FocusNodeid4487363.getChildNodes().getLength(); i_Childid4487363 ++) {
            xml_CurrentNodeid4487363 = xml_FocusNodeid4487363.getChildNodes().item(i_Childid4487363);
            if (xml_CurrentNodeid4487363.getNodeType() == org.w3c.dom.Node.TEXT_NODE) continue;
            if (false) {
            } else if (xml_CurrentNodeid4487363.getNodeName().equals("comment")) {
                W_Watch.comment(xml_CurrentNodeid4487363.getTextContent());
            }
            xml_CurrentNodeid4487363 = xml_FocusNodeid4487363;
        }

        Trace.println("Xml2Model_T_Lock() ->");
    }

    void Xml2Model_T_Date(org.w3c.dom.Node xml_FocusNodeid4482561) {
        Trace.println("Xml2Model_T_Date()");
        org.w3c.dom.Node xml_CurrentNodeid4482561 = xml_FocusNodeid4482561;
        Trace.println("Xml2Model_T_Date() ->");
    }

    protected static class Display {
        public static void println(String J_Text) {
            System.out.println(J_Text);
        }
    }
    protected static class Trace {
        public static void println(String J_Text) {
        }
        public static void printStackTrace(Exception e) {
            e.printStackTrace();
        }
    }
    protected String xpath(org.w3c.dom.Node XML_Node, String J_Expression) {
        try {
            javax.xml.xpath.XPathFactory xml_Factory = javax.xml.xpath.XPathFactory.newInstance();
            javax.xml.xpath.XPath xml_XPath = xml_Factory.newXPath();
            String j_Res = xml_XPath.evaluate(J_Expression, XML_Node);
            return j_Res;
        } catch (Exception j_Exception) {
            Trace.printStackTrace(j_Exception);
            return new String();
        }
    }

    
            private String m_jProjectName;
            private String m_jLocale;
            private watch.Commentable m_wCurrentCommentable;
            private java.util.Collection<watch.Task> m_jTasks;
            private watch.Task m_wCurrentTask;
            private Imputations m_wImputations;
            private Revisions m_wRevisions;

            public XmlInput_1_0() {
                m_jProjectName = null;
                m_jLocale = null;
                m_wCurrentCommentable = null;
                m_jTasks = new java.util.Vector<watch.Task>(); m_wCurrentTask = null;
                m_wCurrentTask = null;
                m_wImputations = new Imputations();
                m_wRevisions = new Revisions();
            }
        
    
            public boolean comment(String J_Comment) {
                if ((m_wCurrentCommentable != null) && (m_wCurrentCommentable.getComments() != null)) {
                    m_wCurrentCommentable.getComments().add(J_Comment);
                    return true;
                }
                return false;
            }
        
    
            public boolean projectName(String J_ProjectName) {
                m_jProjectName = J_ProjectName;
                return true;
            }
        
    
            public boolean locale(String J_Locale) {
                m_jLocale = J_Locale;
                return true;
            }
        
    
            public boolean beginTaskGroup(String J_TaskId, String J_StartDate) {
                watch.Date w_StartDate = null;
                if (J_StartDate != null) {
                    w_StartDate = new watch.Date(J_StartDate);
                }
                watch.Task w_NewTask = new Task(J_TaskId, w_StartDate, 0.0, 0.0, 0.0, null, null, Task.SCHEDULING_NONE);
                if (m_wCurrentTask != null) {
                    m_wCurrentTask.addSubTask(w_NewTask);
                } else {
                    m_jTasks.add(w_NewTask);
                }
                m_wCurrentTask = w_NewTask;
                m_wCurrentCommentable = m_wCurrentTask;
                return true;
            }
            public boolean endTaskGroup() {
                if (m_wCurrentTask != null) {
                    m_wCurrentTask = m_wCurrentTask.getParent();
                }
                m_wCurrentCommentable = m_wCurrentTask;
                return true;
            }
            public boolean singleTask(
                    String J_TaskId,
                    String J_ReferenceStartDate, double D_Reference, double D_Risks, double D_Opportunities,
                    String J_PlannedStartDate, String J_PlannedEndDate, int E_SchedulingMode) {
                watch.Date w_ReferenceStartDate = null;
                    if (J_ReferenceStartDate != null) { w_ReferenceStartDate = new Date(J_ReferenceStartDate); }
                watch.Date w_PlannedStartDate = null;
                    if (J_PlannedStartDate != null) { w_PlannedStartDate = new Date(J_PlannedStartDate); }
                watch.Date w_PlannedEndDate = null;
                    if (J_PlannedEndDate != null) { w_PlannedEndDate = new Date(J_PlannedEndDate); }
                if ((w_PlannedStartDate != null) && (w_PlannedEndDate != null) && (E_SchedulingMode == Task.SCHEDULING_NONE)) {
                    E_SchedulingMode = Task.SCHEDULING_AT_END;
                }
                Task w_NewTask = new Task(
                    J_TaskId,
                    w_ReferenceStartDate, D_Reference, D_Risks, D_Opportunities,
                    w_PlannedStartDate, w_PlannedEndDate, E_SchedulingMode
                );
                if (m_wCurrentTask != null) {
                    m_wCurrentTask.addSubTask(w_NewTask);
                } else {
                    m_jTasks.add(w_NewTask);
                }
                m_wCurrentCommentable = w_NewTask;
                return true;
            }
        
    
            public boolean imputation(String J_UserName, String J_TaskId, String J_Date, double D_Imputed) {
                watch.Date w_Date = null;
                try {
                    w_Date = new watch.Date(J_Date);
                } catch (Exception j_Exception) {
                    watch.Display.printStackTrace(j_Exception);
                    return false;
                }
                m_wCurrentCommentable = m_wImputations.user(J_UserName).date(w_Date).imputation(J_TaskId, w_Date, D_Imputed);
                return true;
            }
            private class Imputations extends java.util.TreeMap<String, UserImputations> {
                public UserImputations user(String J_UserName) {
                    UserImputations w_UserImputations = this.get(J_UserName);
                    if (w_UserImputations == null) {
                        w_UserImputations = new UserImputations();
                        this.put(J_UserName, w_UserImputations);
                    }
                    return w_UserImputations;
                }
            }
            private class UserImputations extends java.util.TreeMap<watch.Date, DateImputations> {
                public DateImputations date(watch.Date W_Date) {
                    DateImputations w_DateImputations = this.get(W_Date);
                    if (w_DateImputations == null) {
                        w_DateImputations = new DateImputations();
                        this.put(W_Date, w_DateImputations);
                    }
                    return w_DateImputations;
                }
            }
            private class DateImputations extends java.util.Vector<Imputation> {
                public Imputation imputation(String J_TaskId, watch.Date W_Date, double D_Imputed) {
                    Imputation w_Imputation = new Imputation();
                    w_Imputation.taskId = J_TaskId;
                    w_Imputation.date = W_Date.toString();
                    w_Imputation.imputed = D_Imputed;
                    this.add(w_Imputation);
                    return w_Imputation;
                }
            }
            private class Imputation extends Commentable {
                public String taskId;
                public String date;
                public double imputed;
            }
        
    
            public boolean revision(String J_TaskId, String J_Date, double D_Remaining, double D_Risks, double D_Opportunities, double D_Earned) {
                watch.Date w_Date = null;
                try {
                    w_Date = new watch.Date(J_Date);
                } catch (Exception j_Exception) {
                    watch.Display.printStackTrace(j_Exception);
                    return false;
                }
                m_wCurrentCommentable = m_wRevisions.date(w_Date).revision(J_TaskId, D_Remaining, D_Risks, D_Opportunities, D_Earned);
                return true;
            }
            public boolean lock(String J_TaskId, String J_Date) {
                watch.Date w_Date = null;
                try {
                    w_Date = new watch.Date(J_Date);
                } catch (Exception j_Exception) {
                    watch.Display.printStackTrace(j_Exception);
                    return false;
                }
                m_wCurrentCommentable = m_wRevisions.date(w_Date).lock(J_TaskId);
                return true;
            }
            private class Revisions extends java.util.TreeMap<watch.Date, DateRevisions> {
                public DateRevisions date(watch.Date W_Date) {
                    DateRevisions w_DateRevisions = this.get(W_Date);
                    if (w_DateRevisions == null) {
                        w_DateRevisions = new DateRevisions();
                        this.put(W_Date, w_DateRevisions);
                    }
                    return w_DateRevisions;
                }
            }
            private class DateRevisions extends java.util.Vector<Revision> {
                public Revision revision(String J_TaskId, double D_Remaining, double D_Risks, double D_Opportunities, double D_Earned) {
                    Revision w_Revision = new Revision();
                    w_Revision.lock = false;
                    w_Revision.taskId = J_TaskId;
                    w_Revision.remaining = D_Remaining;
                    w_Revision.risks = D_Risks;
                    w_Revision.opportunities = D_Opportunities;
                    w_Revision.earned = D_Earned;
                    this.add(w_Revision);
                    return w_Revision;
                }
                public Revision lock(String J_TaskId) {
                    Revision w_Revision = new Revision();
                    w_Revision.lock = true;
                    w_Revision.taskId = J_TaskId;
                    this.add(w_Revision);
                    return w_Revision;
                }
            }
            private class Revision extends Commentable {
                public boolean lock;
                public String userName;
                public String taskId;
                public double remaining;
                public double risks;
                public double opportunities;
                public double earned;
            }
        
    
            public boolean writeFile(String J_FileName) {
                try {
                    model2xml(new java.io.File(J_FileName), null);
                } catch (Exception j_Exception) {
                    watch.Display.printStackTrace(j_Exception);
                }
                return true;
            }
        
    void model2xml(java.io.File J_XmlFile, watch.Watch W_Watch) throws java.lang.Exception {
        javax.xml.parsers.DocumentBuilderFactory xml_BuilderFactory = javax.xml.parsers.DocumentBuilderFactory.newInstance();
        javax.xml.parsers.DocumentBuilder xml_Builder = xml_BuilderFactory.newDocumentBuilder();
        org.w3c.dom.Document xml_Doc = xml_Builder.newDocument();
        org.w3c.dom.Element xml_CurrentNodeid4488367 = xml_Doc.createElement("watch");
        xml_Doc.appendChild(xml_CurrentNodeid4488367);
        Model2Xml_T_WatchNode(xml_CurrentNodeid4488367, W_Watch);
        javax.xml.transform.TransformerFactory xsl_Factory = javax.xml.transform.TransformerFactory.newInstance();
        javax.xml.transform.Transformer xsl_Transformer = xsl_Factory.newTransformer();
        xsl_Transformer.setOutputProperty(javax.xml.transform.OutputKeys.INDENT, "yes");
        xsl_Transformer.setOutputProperty(javax.xml.transform.OutputKeys.ENCODING, "ISO-8859-1");
        javax.xml.transform.dom.DOMSource xml_Source = new javax.xml.transform.dom.DOMSource(xml_Doc);
        javax.xml.transform.stream.StreamResult xml_Result = new javax.xml.transform.stream.StreamResult(new java.io.FileOutputStream(J_XmlFile));
        xsl_Transformer.transform(xml_Source, xml_Result);
    }

    void Model2Xml_T_WatchNode(org.w3c.dom.Node xml_FocusNodeid4486833, watch.Watch W_Watch) {
        Trace.println("Model2Xml_T_WatchNode()");
        org.w3c.dom.Node xml_CurrentNodeid4486833 = xml_FocusNodeid4486833;

        if (true) {
            xml_CurrentNodeid4486833 = createAttribute(xml_FocusNodeid4486833, "version");
            if (true) {
                xml_CurrentNodeid4486833.setTextContent("1.0");
            }
        }
        if (m_jProjectName != null) {
        if (true) {
            xml_CurrentNodeid4486833 = createAttribute(xml_FocusNodeid4486833, "project");
            xml_CurrentNodeid4486833.setTextContent(String.valueOf(m_jProjectName));
        }
        }
        if (m_jLocale != null) {
        if (true) {
            xml_CurrentNodeid4486833 = createAttribute(xml_FocusNodeid4486833, "locale");
            if (m_jLocale.equals("chinese")) {
                xml_CurrentNodeid4486833.setTextContent("chinese");
            }
            if (m_jLocale.equals("english")) {
                xml_CurrentNodeid4486833.setTextContent("english");
            }
            if (m_jLocale.equals("french")) {
                xml_CurrentNodeid4486833.setTextContent("french");
            }
            if (m_jLocale.equals("german")) {
                xml_CurrentNodeid4486833.setTextContent("german");
            }
            if (m_jLocale.equals("italian")) {
                xml_CurrentNodeid4486833.setTextContent("italian");
            }
            if (m_jLocale.equals("japanese")) {
                xml_CurrentNodeid4486833.setTextContent("japanese");
            }
        }
        }
        xml_CurrentNodeid4486833 = xml_FocusNodeid4486833;


        if (m_jTasks.size() > 0) {
        if (true) {
            xml_CurrentNodeid4486833 = createNode(xml_FocusNodeid4486833, "tasks");
            Model2Xml_T_Tasks(xml_CurrentNodeid4486833, W_Watch);
        }
        }
        for (java.util.Iterator<String> j_ImputationIt = m_wImputations.keySet().iterator(); j_ImputationIt.hasNext(); ) {
            String j_UserName = j_ImputationIt.next();
            if (true) {
                xml_CurrentNodeid4486833 = createNode(xml_FocusNodeid4486833, "imputations");
                Model2Xml_T_Imputations(xml_CurrentNodeid4486833, W_Watch, j_UserName);
            }
        }
        for (java.util.Iterator<watch.Date> j_RevisionIt = m_wRevisions.keySet().iterator(); j_RevisionIt.hasNext(); ) {
            watch.Date w_Date = j_RevisionIt.next();
            if (true) {
                xml_CurrentNodeid4486833 = createNode(xml_FocusNodeid4486833, "revisions");
                Model2Xml_T_Revisions(xml_CurrentNodeid4486833, W_Watch, w_Date);
            }
        }
        xml_CurrentNodeid4486833 = xml_FocusNodeid4486833;

        Trace.println("Model2Xml_T_WatchNode() ->");
    }

    void Model2Xml_T_Tasks(org.w3c.dom.Node xml_FocusNodeid4489148, watch.Watch W_Watch) {
        Trace.println("Model2Xml_T_Tasks()");
        org.w3c.dom.Node xml_CurrentNodeid4489148 = xml_FocusNodeid4489148;

        xml_CurrentNodeid4489148 = xml_FocusNodeid4489148;


        for (java.util.Iterator<Task> j_It = m_jTasks.iterator(); j_It.hasNext(); ) {
            watch.Task w_MainTask = j_It.next();
            if (true) {
                xml_CurrentNodeid4489148 = createNode(xml_FocusNodeid4489148, "task");
                Model2Xml_T_Task(xml_CurrentNodeid4489148, W_Watch, w_MainTask);
            }
        }
        xml_CurrentNodeid4489148 = xml_FocusNodeid4489148;

        Trace.println("Model2Xml_T_Tasks() ->");
    }

    void Model2Xml_T_Task(org.w3c.dom.Node xml_FocusNodeid4488742, watch.Watch W_Watch, watch.Task W_Task) {
        Trace.println("Model2Xml_T_Task()");
        org.w3c.dom.Node xml_CurrentNodeid4488742 = xml_FocusNodeid4488742;

        
            boolean b_IsGroup = (! W_Task.isFinal());
        
        if (true) {
            xml_CurrentNodeid4488742 = createAttribute(xml_FocusNodeid4488742, "id");
            xml_CurrentNodeid4488742.setTextContent(String.valueOf(W_Task.getId()));
        }
        if (! b_IsGroup) {
        if (false) {
        if (true) {
            xml_CurrentNodeid4488742 = createAttribute(xml_FocusNodeid4488742, "time");
        }
        }
        if (true) {
            xml_CurrentNodeid4488742 = createAttribute(xml_FocusNodeid4488742, "value");
            xml_CurrentNodeid4488742.setTextContent(String.valueOf(W_Task.getReference()));
        }
        if (true) {
            xml_CurrentNodeid4488742 = createAttribute(xml_FocusNodeid4488742, "risks");
            xml_CurrentNodeid4488742.setTextContent(String.valueOf(W_Task.getReferenceRisks()));
        }
        if (true) {
            xml_CurrentNodeid4488742 = createAttribute(xml_FocusNodeid4488742, "opportunities");
            xml_CurrentNodeid4488742.setTextContent(String.valueOf(W_Task.getReferenceOpportunities()));
        }
        }
        if ((W_Task.getReferenceStartDate() != null)
                                    && ((W_Task.getParent() == null)
                                                || (W_Task.getParent().getReferenceStartDate() == null)
                                                || (! W_Task.getReferenceStartDate().equals(W_Task.getParent().getReferenceStartDate())))) {
        if (true) {
            xml_CurrentNodeid4488742 = createAttribute(xml_FocusNodeid4488742, "start-date");
            xml_CurrentNodeid4488742.setTextContent(String.valueOf(W_Task.getReferenceStartDate()));
        }
        }
        if (! b_IsGroup) {
        if (W_Task.getPlannedStartDate() != null) {
        if (true) {
            xml_CurrentNodeid4488742 = createAttribute(xml_FocusNodeid4488742, "plan-start");
            xml_CurrentNodeid4488742.setTextContent(String.valueOf(W_Task.getPlannedStartDate()));
        }
        }
        if (W_Task.getPlannedEndDate() != null) {
        if (true) {
            xml_CurrentNodeid4488742 = createAttribute(xml_FocusNodeid4488742, "plan-end");
            xml_CurrentNodeid4488742.setTextContent(String.valueOf(W_Task.getPlannedEndDate()));
        }
        }
        if (W_Task.getSchedulingMode() != watch.Task.SCHEDULING_NONE) {
        if (true) {
            xml_CurrentNodeid4488742 = createAttribute(xml_FocusNodeid4488742, "plan-evm");
            if (W_Task.getSchedulingMode() == watch.Task.SCHEDULING_AT_END) {
                xml_CurrentNodeid4488742.setTextContent("at-end");
            }
            if (W_Task.getSchedulingMode() == watch.Task.SCHEDULING_LINEAR) {
                xml_CurrentNodeid4488742.setTextContent("linear");
            }
        }
        }
        }
        xml_CurrentNodeid4488742 = xml_FocusNodeid4488742;


        for (java.util.Iterator<String> j_CommentsIt = W_Task.getComments().iterator(); j_CommentsIt.hasNext(); ) {
            if (true) {
                xml_CurrentNodeid4488742 = createNode(xml_FocusNodeid4488742, "comment");
                xml_CurrentNodeid4488742.setTextContent(String.valueOf(j_CommentsIt.next()));
            }
        }
        for (java.util.Iterator<watch.Task> j_SubTasksIt = W_Task.getSubTaskIterator(); j_SubTasksIt.hasNext(); ) {
            watch.Task w_SubTask = j_SubTasksIt.next();
            if (true) {
                xml_CurrentNodeid4488742 = createNode(xml_FocusNodeid4488742, "task");
                Model2Xml_T_Task(xml_CurrentNodeid4488742, W_Watch, w_SubTask);
            }
        }
        xml_CurrentNodeid4488742 = xml_FocusNodeid4488742;

        Trace.println("Model2Xml_T_Task() ->");
    }

    void Model2Xml_T_Imputations(org.w3c.dom.Node xml_FocusNodeid4498741, watch.Watch W_Watch, String J_UserName) {
        Trace.println("Model2Xml_T_Imputations()");
        org.w3c.dom.Node xml_CurrentNodeid4498741 = xml_FocusNodeid4498741;

        if (true) {
            xml_CurrentNodeid4498741 = createAttribute(xml_FocusNodeid4498741, "user");
            xml_CurrentNodeid4498741.setTextContent(String.valueOf(J_UserName));
        }
        xml_CurrentNodeid4498741 = xml_FocusNodeid4498741;


        UserImputations w_UserImputations = m_wImputations.user(J_UserName);
        for (java.util.Iterator<watch.Date> j_It = w_UserImputations.keySet().iterator(); j_It.hasNext(); ) {
            watch.Date w_Date = j_It.next();
            if (true) {
                xml_CurrentNodeid4498741 = createNode(xml_FocusNodeid4498741, "day");
                Model2Xml_T_ImputationDay(xml_CurrentNodeid4498741, W_Watch, J_UserName, w_Date);
            }
        }
        xml_CurrentNodeid4498741 = xml_FocusNodeid4498741;

        Trace.println("Model2Xml_T_Imputations() ->");
    }

    void Model2Xml_T_ImputationDay(org.w3c.dom.Node xml_FocusNodeid4495461, watch.Watch W_Watch, String J_UserName, watch.Date W_Date) {
        Trace.println("Model2Xml_T_ImputationDay()");
        org.w3c.dom.Node xml_CurrentNodeid4495461 = xml_FocusNodeid4495461;
        String j_ImputationDate = null;

        if (true) {
            xml_CurrentNodeid4495461 = createAttribute(xml_FocusNodeid4495461, "date");
            xml_CurrentNodeid4495461.setTextContent(String.valueOf(W_Date));
        }
        xml_CurrentNodeid4495461 = xml_FocusNodeid4495461;


        DateImputations w_DateImputations = m_wImputations.user(J_UserName).date(W_Date);
        for (java.util.Iterator<Imputation> j_It = w_DateImputations.iterator(); j_It.hasNext(); ) {
            Imputation w_Imputation = j_It.next();
            if (true) {
                xml_CurrentNodeid4495461 = createNode(xml_FocusNodeid4495461, "imputation");
                Model2Xml_T_Imputation(xml_CurrentNodeid4495461, W_Watch, j_ImputationDate, w_Imputation);
            }
        }
        xml_CurrentNodeid4495461 = xml_FocusNodeid4495461;

        Trace.println("Model2Xml_T_ImputationDay() ->");
    }

    void Model2Xml_T_Imputation(org.w3c.dom.Node xml_FocusNodeid4490881, watch.Watch W_Watch, String J_ImputationDate, Imputation W_Imputation) {
        Trace.println("Model2Xml_T_Imputation()");
        org.w3c.dom.Node xml_CurrentNodeid4490881 = xml_FocusNodeid4490881;

        if (true) {
            xml_CurrentNodeid4490881 = createAttribute(xml_FocusNodeid4490881, "task");
            xml_CurrentNodeid4490881.setTextContent(String.valueOf(W_Imputation.taskId));
        }
        if (false) {
        if (true) {
            xml_CurrentNodeid4490881 = createAttribute(xml_FocusNodeid4490881, "time");
        }
        }
        if (true) {
            xml_CurrentNodeid4490881 = createAttribute(xml_FocusNodeid4490881, "value");
            xml_CurrentNodeid4490881.setTextContent(String.valueOf(W_Imputation.imputed));
        }
        xml_CurrentNodeid4490881 = xml_FocusNodeid4490881;


        for (java.util.Iterator<String> j_CommentsIt = W_Imputation.getComments().iterator(); j_CommentsIt.hasNext(); ) {
            if (true) {
                xml_CurrentNodeid4490881 = createNode(xml_FocusNodeid4490881, "comment");
                xml_CurrentNodeid4490881.setTextContent(String.valueOf(j_CommentsIt.next()));
            }
        }
        xml_CurrentNodeid4490881 = xml_FocusNodeid4490881;

        Trace.println("Model2Xml_T_Imputation() ->");
    }

    void Model2Xml_T_Revisions(org.w3c.dom.Node xml_FocusNodeid4489913, watch.Watch W_Watch, watch.Date W_Date) {
        Trace.println("Model2Xml_T_Revisions()");
        org.w3c.dom.Node xml_CurrentNodeid4489913 = xml_FocusNodeid4489913;

        if (true) {
            xml_CurrentNodeid4489913 = createAttribute(xml_FocusNodeid4489913, "date");
            xml_CurrentNodeid4489913.setTextContent(String.valueOf(W_Date));
        }
        xml_CurrentNodeid4489913 = xml_FocusNodeid4489913;


        DateRevisions w_DateRevisions = m_wRevisions.date(W_Date);
        for (java.util.Iterator<Revision> j_It = w_DateRevisions.iterator(); j_It.hasNext(); ) {
            Revision w_Revision = j_It.next();
        if (! w_Revision.lock) {
        if (true) {
            xml_CurrentNodeid4489913 = createNode(xml_FocusNodeid4489913, "revision");
            Model2Xml_T_Revision(xml_CurrentNodeid4489913, W_Watch, w_Revision);
        }
        }
        if (w_Revision.lock) {
        if (true) {
            xml_CurrentNodeid4489913 = createNode(xml_FocusNodeid4489913, "lock");
            Model2Xml_T_Lock(xml_CurrentNodeid4489913, W_Watch, w_Revision);
        }
        }
        }
        xml_CurrentNodeid4489913 = xml_FocusNodeid4489913;

        Trace.println("Model2Xml_T_Revisions() ->");
    }

    void Model2Xml_T_Revision(org.w3c.dom.Node xml_FocusNodeid4489060, watch.Watch W_Watch, Revision W_Revision) {
        Trace.println("Model2Xml_T_Revision()");
        org.w3c.dom.Node xml_CurrentNodeid4489060 = xml_FocusNodeid4489060;

        if (true) {
            xml_CurrentNodeid4489060 = createAttribute(xml_FocusNodeid4489060, "task");
            xml_CurrentNodeid4489060.setTextContent(String.valueOf(W_Revision.taskId));
        }
        if (false) {
        if (true) {
            xml_CurrentNodeid4489060 = createAttribute(xml_FocusNodeid4489060, "date");
        }
        }
        if (false) {
        if (true) {
            xml_CurrentNodeid4489060 = createAttribute(xml_FocusNodeid4489060, "time");
        }
        }
        if (W_Revision.remaining >= 0) {
        if (true) {
            xml_CurrentNodeid4489060 = createAttribute(xml_FocusNodeid4489060, "value");
            xml_CurrentNodeid4489060.setTextContent(String.valueOf(W_Revision.remaining));
        }
        }
        if (W_Revision.risks >= 0) {
        if (true) {
            xml_CurrentNodeid4489060 = createAttribute(xml_FocusNodeid4489060, "risks");
            xml_CurrentNodeid4489060.setTextContent(String.valueOf(W_Revision.risks));
        }
        }
        if (W_Revision.opportunities >= 0) {
        if (true) {
            xml_CurrentNodeid4489060 = createAttribute(xml_FocusNodeid4489060, "opportunities");
            xml_CurrentNodeid4489060.setTextContent(String.valueOf(W_Revision.opportunities));
        }
        }
        if (W_Revision.earned >= 0) {
        if (true) {
            xml_CurrentNodeid4489060 = createAttribute(xml_FocusNodeid4489060, "earned");
            xml_CurrentNodeid4489060.setTextContent(String.valueOf(W_Revision.earned));
        }
        }
        xml_CurrentNodeid4489060 = xml_FocusNodeid4489060;


        for (java.util.Iterator<String> j_CommentsIt = W_Revision.getComments().iterator(); j_CommentsIt.hasNext(); ) {
            if (true) {
                xml_CurrentNodeid4489060 = createNode(xml_FocusNodeid4489060, "comment");
                xml_CurrentNodeid4489060.setTextContent(String.valueOf(j_CommentsIt.next()));
            }
        }
        xml_CurrentNodeid4489060 = xml_FocusNodeid4489060;

        Trace.println("Model2Xml_T_Revision() ->");
    }

    void Model2Xml_T_Lock(org.w3c.dom.Node xml_FocusNodeid4487363, watch.Watch W_Watch, Revision W_Revision) {
        Trace.println("Model2Xml_T_Lock()");
        org.w3c.dom.Node xml_CurrentNodeid4487363 = xml_FocusNodeid4487363;

        if (true) {
            xml_CurrentNodeid4487363 = createAttribute(xml_FocusNodeid4487363, "task");
            xml_CurrentNodeid4487363.setTextContent(String.valueOf(W_Revision.taskId));
        }
        if (false) {
        if (true) {
            xml_CurrentNodeid4487363 = createAttribute(xml_FocusNodeid4487363, "date");
        }
        }
        xml_CurrentNodeid4487363 = xml_FocusNodeid4487363;


        for (java.util.Iterator<String> j_CommentsIt = W_Revision.getComments().iterator(); j_CommentsIt.hasNext(); ) {
            if (true) {
                xml_CurrentNodeid4487363 = createNode(xml_FocusNodeid4487363, "comment");
                xml_CurrentNodeid4487363.setTextContent(String.valueOf(j_CommentsIt.next()));
            }
        }
        xml_CurrentNodeid4487363 = xml_FocusNodeid4487363;

        Trace.println("Model2Xml_T_Lock() ->");
    }

    void Model2Xml_T_Date(org.w3c.dom.Node xml_FocusNodeid4482561) {
        Trace.println("Model2Xml_T_Date()");
        org.w3c.dom.Node xml_CurrentNodeid4482561 = xml_FocusNodeid4482561;
        Trace.println("Model2Xml_T_Date() ->");
    }

    protected org.w3c.dom.Element createNode(org.w3c.dom.Node XML_Node, String J_NodeName) {
        try {
            org.w3c.dom.Document xml_Doc = XML_Node.getOwnerDocument();
            org.w3c.dom.Element xml_CurrentNode = xml_Doc.createElement(J_NodeName);
            XML_Node.appendChild(xml_CurrentNode);
            return xml_CurrentNode;
        } catch (Exception j_Exception) {
            Trace.printStackTrace(j_Exception);
            return null;
        }
    }

    protected org.w3c.dom.Attr createAttribute(org.w3c.dom.Node XML_Node, String J_AttributeName) {
        try {
            org.w3c.dom.Document xml_Doc = XML_Node.getOwnerDocument();
            org.w3c.dom.Attr xml_Attribute = xml_Doc.createAttribute(J_AttributeName);
            XML_Node.getAttributes().setNamedItem(xml_Attribute);
            return xml_Attribute;
        } catch (Exception j_Exception) {
            Trace.printStackTrace(j_Exception);
            return null;
        }
    }

}
