<?xml version="1.0" encoding="iso-8859-1"?>

<!--
    Copyright (c) 2008-2010, Alexis Royer, http://alexis.royer.free.fr/Watch

    All rights reserved.

    Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

        * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
        * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
        * Neither the name of the Watch project nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->

<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" encoding="iso-8859-1" indent="yes"/>

<xsl:param name="STR_Title">
    <xsl:choose>
    <xsl:when test="/watch/@project"><xsl:value-of select="/watch/@project"/></xsl:when>
    <xsl:otherwise><xsl:text>Watch</xsl:text></xsl:otherwise>
    </xsl:choose>
    <xsl:text>, </xsl:text>
    <xsl:if test="/watch/@start">
        <xsl:text>from </xsl:text><xsl:value-of select="/watch/@start"/><xsl:text> </xsl:text>
    </xsl:if>
    <xsl:if test="/watch/@end">
        <xsl:text>up to </xsl:text><xsl:value-of select="/watch/@end"/><xsl:text> </xsl:text>
    </xsl:if>
    <xsl:if test="/watch/@reference">
        <xsl:text>- vs </xsl:text><xsl:value-of select="/watch/@reference"/>
    </xsl:if>
</xsl:param>
<xsl:param name="B_EVM">
    <xsl:choose>
    <xsl:when test="count(/watch/task/@planned) &gt; 0">1</xsl:when>
    <xsl:otherwise>0</xsl:otherwise>
    </xsl:choose>
</xsl:param>

<xsl:param name="STR_FormatNumber" select="'0.00'"/>
<xsl:param name="I_TaskColWidth">
    <xsl:choose>
    <xsl:when test="$B_EVM = 1">300</xsl:when>
    <xsl:otherwise>550</xsl:otherwise>
    </xsl:choose>
</xsl:param>
<xsl:param name="I_ValueColWidth"           select="55"/>
<xsl:param name="I_SeparationColWidth"      select="5"/>
<xsl:param name="STR_ThColor"               select="'#e0e0e0'"/>
<xsl:param name="STR_ThColor1"              select="'#d0d0df'"/>
<xsl:param name="STR_ThColor2"              select="'#c8c8d8'"/>
<xsl:param name="STR_NoColor"               select="'#cccccc'"/>
<xsl:param name="D_RiskRatio"               select="0.5"/>

<xsl:param name="STR_TaskColTitle"          select="'Task'"/>
<xsl:param name="STR_ReferenceColTitle"     select="'Reference'"/>
<xsl:param name="STR_RemainingColTitle"     select="'Remaining'"/>
<xsl:param name="STR_FinalColTitle"         select="'Final'"/>
<xsl:param name="STR_EVMColTitle"           select="'EVM'"/>
<xsl:param name="STR_ImputedColTitle"       select="'Imputed'"/>
<xsl:param name="STR_ValueColTitle"         select="'Value'"/>
<xsl:param name="STR_RisksColTitle"         select="'Risks'"/>
<xsl:param name="STR_OpportunitiesColTitle" select="'Opport.'"/>
<xsl:param name="STR_CheckColTitle"         select="'Check'"/>
<xsl:param name="STR_BACColTitle"           select="'BAC'"/>
<xsl:param name="STR_BCWSColTitle"          select="'BCWS'"/>
<xsl:param name="STR_BCWPColTitle"          select="'BCWP'"/>
<xsl:param name="STR_ACWPColTitle"          select="'ACWP'"/>
<xsl:param name="STR_SPIColTitle"           select="'SPI'"/>
<xsl:param name="STR_CPIColTitle"           select="'CPI'"/>
<xsl:param name="STR_EACColTitle"           select="'EAC'"/>


<xsl:template match="/watch">
    <html>
        <head>
            <title><xsl:value-of select="$STR_Title"/></title>
    <style type="text/css">
<xsl:comment>
.directory { font-size: 10pt; font-weight: bold; }
.directory h3 { margin: 0px; margin-top: 1em; font-size: 11pt; }
.directory p { margin: 0px; white-space: nowrap; }
.directory div { display: none; margin: 0px; }
.directory img { vertical-align: middle; }
.directory tr { display: none; margin: 0px; }
.directory tr td table { display: block; margin: 0px; }
.directory tr td table tr { display: block; margin: 0px; }
.directory a.expand { font-size: 6pt; color: gray; text-decoration: none; text-align: right; }
</xsl:comment>
    </style>
            <script type="text/javascript">
<xsl:comment>
//! @brief Show a debug message.
function debug(message) {
    //alert(message);
}

//! @brief First HTML child of a kind.
//! @param parentNode Parent node whose children should be scanned.
//! @param childNodeName Child node name researched.
//! @param childIndex Index of the child of the kind. -1 for the latest.
//! @return The HTML child of the kind researched. null if not found.
function htmlChild(parentNode, childNodeName, childIndex) {
    var resultNode = null;

    var childNode = parentNode.firstChild;
    while (childNode != null) {
        //debug("htmlChild(): childNode = " + childNode + ", childNode.nodeName = " + childNode.nodeName);
        if (childNode.nodeName == childNodeName) {
            resultNode = childNode;
            if (childIndex &lt;= 0) {
                break;
            } else {
                childIndex = childIndex - 1;
            }
        }
        childNode = childNode.nextSibling;
    }

    //debug("htmlChild():" + " parent = " + parentNode + " [\"" + childNodeName + "\", " + childIndex + "]" + " => " + resultNode);
    return resultNode;
}

//! @brief Check the image, whether a "plus" or a "minus" image.
//! @param trNode Row to check the image within.
//! @param plus True if a "plus" image should, false for a "minus" image.
function checkImage(trNode, plus) {
    if ((trNode != null) &amp;&amp; (trNode.nodeName == "TR")) {
        var tdNode = htmlChild(trNode, "TD", 0);
        if (tdNode != null) {
            var innerTable = htmlChild(tdNode, "TABLE", 0);
            innerTable = htmlChild(innerTable, "TBODY", 0);
            if (innerTable != null) {
                var innerTr = htmlChild(innerTable, "TR", 0);
                if (innerTr != null) {
                    var innerTd = htmlChild(innerTr, "TD", 0);
                    if (innerTd != null) {
                        for (var imgNode = htmlChild(innerTd, "IMG", 0); imgNode != null; imgNode = imgNode.nextSibling) {
                            if (imgNode.nodeName == "IMG") {
                                debug("imgNode.src = " + imgNode.src);
                                var l = imgNode.src.length;
                                if (false) {
                                } else if ((plus) &amp;&amp; (imgNode.src.substring(l-13,l) == "ftv2mnode.png")) {
                                    imgNode.src = imgNode.src.substring(0,l-13) + "ftv2pnode.png";
                                } else if ((plus) &amp;&amp; (imgNode.src.substring(l-17,l) == "ftv2mlastnode.png")) {
                                    imgNode.src = imgNode.src.substring(0,l-17) + "ftv2plastnode.png";
                                } else if ((! plus) &amp;&amp; (imgNode.src.substring(l-13,l) == "ftv2pnode.png")) {
                                    imgNode.src = imgNode.src.substring(0,l-13) + "ftv2mnode.png";
                                } else if ((! plus) &amp;&amp; (imgNode.src.substring(l-17,l) == "ftv2plastnode.png")) {
                                    imgNode.src = imgNode.src.substring(0,l-17) + "ftv2mlastnode.png";
                                }
                                debug("imgNode.src = " + imgNode.src);
                            }
                        }
                    }
                }
            }
        }
    }
}
/*############
                    debug("innerTr = " + innerTr);
                    debug("innerTr.nodeName = " + innerTr.nodeName);
                }
var imgNode = tdNode.firstChild;
debug("imgNode = " + imgNode);
while (imgNode != null) {
    debug("imgNode = " + imgNode);
    debug("imgNode.nodeName = " + imgNode.nodeName);
    if (imgNode.nodeName == "IMG") {
        // This is an image.
        debug("imgNode.src = " + imgNode.src);
        var l = imgNode.src.length;
        if (false) {
        } else if ((plus) &amp;&amp; (imgNode.src.substring(l-13,l) == "ftv2mnode.png")) {
            imgNode.src = imgNode.src.substring(0,l-13) + "ftv2pnode.png";
        } else if ((plus) &amp;&amp; (imgNode.src.substring(l-17,l) == "ftv2mlastnode.png")) {
            imgNode.src = imgNode.src.substring(0,l-17) + "ftv2plastnode.png";
        } else if ((! plus) &amp;&amp; (imgNode.src.substring(l-13,l) == "ftv2pnode.png")) {
            imgNode.src = imgNode.src.substring(0,l-13) + "ftv2mnode.png";
        } else if ((! plus) &amp;&amp; (imgNode.src.substring(l-17,l) == "ftv2plastnode.png")) {
            imgNode.src = imgNode.src.substring(0,l-17) + "ftv2mlastnode.png";
        }
        debug("imgNode.src = " + imgNode.src);
    }
    imgNode = imgNode.nextSibling;
}
            }
        }
    }
}*/

function showHideRows(trNode, childClass, expand, all) {
    // Set this row image.
    checkImage(trNode, ! expand);

    // Scan down all tables rows below and look for children rows.
    var node = trNode;
    while (node != null) {
        if (node.nodeName == "TR") {
            // This is a row.
            //debug("node.className = " + node.className);
            if (expand) {
                if (all) {
                    // Open direct children and sub-children.
                    var l = childClass.length;
                    if (node.className.substring(0,l) == childClass) {
                        //debug("Displaying node");
                        node.style.display = "block";
                        checkImage(node, false);
                    }
                } else {
                    // Open direct children only.
                    if (node.className == childClass) {
                        //debug("Displaying node");
                        node.style.display = "block";
                    }
                }
            } else {
                // Close direct children and sub-children.
                var l = childClass.length;
                if (node.className.substring(0,l) == childClass) {
                    //debug("Hiding node");
                    node.style.display = "none";
                    checkImage(node, true);
                }
            }
        }
        // Next.
        node = node.nextSibling;
    }
}

//! @brief TR node retrieval from a toggle node.
//! @param toggleNode Toggle control node (either an image or a link).
//! @return TR node the toggle node is related to.
function trNode(toggleNode) {
    // Move from link node to table row node.
    var innerTdNode = toggleNode.parentNode;
    var innerTrNode = innerTdNode.parentNode;
    var innerTableNode = innerTrNode.parentNode.parentNode;
    var tdNode = innerTableNode.parentNode;
    var trNode = tdNode.parentNode;

    return trNode;
}

//! @brief Open/close a table row.
//! @param childClass Class of children rows.
//! @param imageNode +/- image the user has clicked.
function toggleRow(childClass, imageNode) {
    // Change +/- image
    var expand = true;
    var l = imageNode.src.length;
    //debug("imageNode.src = " + imageNode.src);
    if (false) {
    } else if (imageNode.src.substring(l-13,l) == "ftv2mnode.png") {
        //imageNode.src = imageNode.src.substring(0,l-13) + "ftv2pnode.png";
        expand = false;
    } else if (imageNode.src.substring(l-17,l) == "ftv2mlastnode.png") {
        //imageNode.src = imageNode.src.substring(0,l-17) + "ftv2plastnode.png";
        expand = false;
    } else if (imageNode.src.substring(l-13,l) == "ftv2pnode.png") {
        //imageNode.src = imageNode.src.substring(0,l-13) + "ftv2mnode.png";
        expand = true;
    } else if (imageNode.src.substring(l-17,l) == "ftv2plastnode.png") {
        //imageNode.src = imageNode.src.substring(0,l-17) + "ftv2mlastnode.png";
        expand = true;
    }
    //debug("imageNode.src = " + imageNode.src);

    showHideRows(trNode(imageNode), childClass, expand, false);
}

function toggleAll(childClass, linkNode, expand)
{
    showHideRows(trNode(linkNode), childClass, expand, true);
}
</xsl:comment>
            </script>
        </head>

        <body>
            <h1><xsl:value-of select="$STR_Title"/></h1>

            <p>
            <b>User:</b>
                <xsl:choose>
                <xsl:when test="/watch/@user"><xsl:value-of select="/watch/@user"/></xsl:when>
                <xsl:otherwise>Everyone</xsl:otherwise>
                </xsl:choose>
                <br/>
            <b>Reference date:</b>
                <xsl:choose>
                <xsl:when test="/watch/@reference"><xsl:value-of select="/watch/@reference"/></xsl:when>
                <xsl:otherwise>Initial reference</xsl:otherwise>
                </xsl:choose>
                <br/>
            <b>Start date:</b>
                <xsl:choose>
                <xsl:when test="/watch/@start"><xsl:value-of select="/watch/@start"/></xsl:when>
                <xsl:otherwise>None</xsl:otherwise>
                </xsl:choose>
                <br/>
            <b>End date:</b>
                <xsl:choose>
                <xsl:when test="/watch/@end"><xsl:value-of select="/watch/@end"/></xsl:when>
                <xsl:otherwise>None</xsl:otherwise>
                </xsl:choose>
                <br/>
            </p>

            <table border="0" cellspacing="0">
                <tr class="root_task">
                    <th bgcolor="#ffffff"></th>
                    <th bgcolor="#ffffff"></th>
                    <th bgcolor="{$STR_ThColor1}" colspan="3"><xsl:value-of select="$STR_ReferenceColTitle"/></th>
                    <th bgcolor="{$STR_ThColor2}"></th>
                    <th bgcolor="{$STR_ThColor1}" colspan="3"><xsl:value-of select="$STR_RemainingColTitle"/></th>
                    <th bgcolor="{$STR_ThColor2}" colspan="2"><xsl:value-of select="$STR_FinalColTitle"/></th>
                    <xsl:if test="$B_EVM = 1">
                        <th bgcolor="#ffffff"></th>
                        <th bgcolor="{$STR_ThColor1}" colspan="7"><xsl:value-of select="$STR_EVMColTitle"/></th>
                    </xsl:if>
                </tr>
                <tr class="root_task" bgcolor="{$STR_ThColor}">
                    <th width="{$I_TaskColWidth}"><xsl:value-of select="$STR_TaskColTitle"/></th>
                    <th width="{$I_SeparationColWidth}" bgcolor="#ffffff"></th>
                    <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_ValueColTitle"/></th>
                    <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_RisksColTitle"/></th>
                    <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_OpportunitiesColTitle"/></th>
                    <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_ImputedColTitle"/></th>
                    <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_ValueColTitle"/></th>
                    <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_RisksColTitle"/></th>
                    <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_OpportunitiesColTitle"/></th>
                    <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_ValueColTitle"/></th>
                    <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_CheckColTitle"/></th>
                    <xsl:if test="$B_EVM = 1">
                        <th width="{$I_SeparationColWidth}" bgcolor="#ffffff"></th>
                        <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_BACColTitle"/></th>
                        <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_BCWSColTitle"/></th>
                        <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_BCWPColTitle"/></th>
                        <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_ACWPColTitle"/></th>
                        <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_SPIColTitle"/></th>
                        <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_CPIColTitle"/></th>
                        <th width="{$I_ValueColWidth}"><xsl:value-of select="$STR_EACColTitle"/></th>
                    </xsl:if>
                </tr>
            </table>
            <div class="directory">
            <table border="0" cellspacing="0">
                <xsl:call-template name="T_Task"/>
            </table>
            </div>
        </body>
    </html>
</xsl:template>

<xsl:template name="T_Task">
    <xsl:param name="STR_TaskId" select="0"/>
    <xsl:param name="STR_TaskClass" select="'root_task'"/>

    <xsl:variable name="b_TaskNode" select="count(self::task) &gt; 0"/>
    <xsl:variable name="b_HasChildren" select="count(./task) &gt; 0"/>

    <xsl:if test="$b_TaskNode = 1">
        <tr class="{$STR_TaskClass}">
            <xsl:if test="($STR_TaskClass='root_task') or ($STR_TaskClass='child_of_1')">
                <xsl:attribute name="style"><xsl:text>display: block;</xsl:text></xsl:attribute>
            </xsl:if>
            <td align="left" width="{$I_TaskColWidth}">
                <table border="0" cellspacing="0">
                <tr>
                <td valign="top">
                    <!-- Set the @width attribute depending on the number of images. -->
                    <xsl:variable name="i_ImageCount" select="count(ancestor::task) + 2"/>
                    <xsl:variable name="i_SmallImageWidth" select="15"/>
                    <xsl:variable name="i_BigImageWidth" select="23"/>
                    <xsl:variable name="i_ImageOffset" select="5"/>
                    <xsl:attribute name="width">
                        <xsl:value-of select="(($i_ImageCount - 1) * ($i_SmallImageWidth + $i_ImageOffset)) + ($i_BigImageWidth + $i_ImageOffset)"/>
                    </xsl:attribute>

                    <xsl:call-template name="T_Images">
                        <xsl:with-param name="STR_TaskId" select="$STR_TaskId"/>
                    </xsl:call-template>
                </td>
                <td valign="top">
                    <xsl:choose>
                    <xsl:when test="@id"><xsl:value-of select="@id"/></xsl:when>
                    <xsl:when test="@date"><xsl:value-of select="@date"/></xsl:when>
                    </xsl:choose>
                </td>
                <xsl:if test="$b_HasChildren = 1">
                    <td valign="center">
                        <xsl:text> </xsl:text>
                        <a name="{$STR_TaskId}"/>
                        <xsl:element name="a">
                            <xsl:attribute name="href">#<xsl:value-of select="$STR_TaskId"/></xsl:attribute>
                            <xsl:attribute name="onclick">toggleAll('child_of_<xsl:value-of select="$STR_TaskId"/>', this, true)</xsl:attribute>
                            <xsl:attribute name="class">expand</xsl:attribute>
                            <xsl:text>&gt;&gt;</xsl:text>
                        </xsl:element>
                    </td>
                </xsl:if>
                </tr>
                </table>
            </td>
            <td align="right" width="{$I_SeparationColWidth}">
            </td>
            <td align="right" width="{$I_ValueColWidth}">
                <xsl:call-template name="T_CellColor">
                    <xsl:with-param name="STR_Text"><xsl:value-of select="format-number(@reference, $STR_FormatNumber)"/></xsl:with-param>
                </xsl:call-template>
            </td>
            <td align="right" width="{$I_ValueColWidth}">
                <xsl:call-template name="T_CellColor">
                    <xsl:with-param name="STR_Text"><xsl:value-of select="format-number(@reference-risks, $STR_FormatNumber)"/></xsl:with-param>
                </xsl:call-template>
            </td>
            <td align="right" width="{$I_ValueColWidth}">
                <xsl:call-template name="T_CellColor">
                    <xsl:with-param name="STR_Text"><xsl:value-of select="format-number(@reference-opportunities, $STR_FormatNumber)"/></xsl:with-param>
                </xsl:call-template>
            </td>
            <td align="right" width="{$I_ValueColWidth}">
                <xsl:call-template name="T_CellColor">
                    <xsl:with-param name="STR_Text"><xsl:value-of select="format-number(@imputed, $STR_FormatNumber)"/></xsl:with-param>
                </xsl:call-template>
            </td>
            <td align="right" width="{$I_ValueColWidth}">
                <xsl:call-template name="T_CellColor">
                    <xsl:with-param name="STR_Text"><xsl:value-of select="format-number(@remaining, $STR_FormatNumber)"/></xsl:with-param>
                </xsl:call-template>
            </td>
            <td align="right" width="{$I_ValueColWidth}">
                <xsl:call-template name="T_CellColor">
                    <xsl:with-param name="STR_Text"><xsl:value-of select="format-number(@remaining-risks, $STR_FormatNumber)"/></xsl:with-param>
                </xsl:call-template>
            </td>
            <td align="right" width="{$I_ValueColWidth}">
                <xsl:call-template name="T_CellColor">
                    <xsl:with-param name="STR_Text"><xsl:value-of select="format-number(@remaining-opportunities, $STR_FormatNumber)"/></xsl:with-param>
                </xsl:call-template>
            </td>
            <td align="right" width="{$I_ValueColWidth}">
                <xsl:call-template name="T_CellColor">
                    <xsl:with-param name="STR_Text">
                        <xsl:choose>
                        <xsl:when test="@reference &lt; 0"><xsl:value-of select="format-number(0, $STR_FormatNumber)"/></xsl:when>
                        <xsl:otherwise><xsl:value-of select="format-number(@imputed + @remaining, $STR_FormatNumber)"/></xsl:otherwise>
                        </xsl:choose>
                    </xsl:with-param>
                </xsl:call-template>
            </td>
            <td align="right" width="{$I_ValueColWidth}">
                <xsl:call-template name="T_CellColor">
                    <xsl:with-param name="STR_Text">
                        <xsl:choose>
                        <xsl:when test="@reference &lt; 0"><xsl:value-of select="format-number(0, $STR_FormatNumber)"/></xsl:when>
                        <xsl:otherwise><xsl:value-of select="format-number(@reference - @imputed - @remaining, $STR_FormatNumber)"/></xsl:otherwise>
                        </xsl:choose>
                    </xsl:with-param>
                </xsl:call-template>
            </td>
            <xsl:if test="$B_EVM = 1">
                <!-- BAC (Budgeted At Completion) -->
                <xsl:variable name="BAC" select="number(@reference)"/>
                <!-- BCWS (Budgeted Cost of Work Scheduled) -->
                <xsl:variable name="BCWS" select="number(@planned)"/>
                <!-- BCWP (Budgeted Cost of Work Performed) -->
                <xsl:variable name="BCWP" select="number(@earned)"/>
                <!-- ACWP (Actual Cost of Work Performed) -->
                <xsl:variable name="ACWP" select="number(@imputed)"/>
                <!-- CV (Cost Variance) -->
                <xsl:variable name="CV" select="$BCWP - $ACWP"/>
                <!-- CVP (Cost Variance Percentage) -->
                <xsl:variable name="CVP" select="$CV div $BCWP"/>
                <!-- SV (Schedule Variance) -->
                <xsl:variable name="SV" select="$BCWP - $BCWS"/>
                <!-- SVP (Schedule Variance Percentage) -->
                <xsl:variable name="SVP" select="$SV div $BCWS"/>
                <!-- CPI (Cost Performance Index) = BCWP / ACWP -->
                <xsl:variable name="CPI" select="$BCWP div $ACWP"/>
                <!-- SPI (Schedule Performance Index) = BCWP / BCWS -->
                <xsl:variable name="SPI" select="$BCWP div $BCWS"/>
                <!-- EAC (Estimated At Completion) = BAC * ACWP / BCWP -->
                <xsl:variable name="EAC" select="$BAC * $ACWP div $BCWP"/>
                <xsl:variable name="EAC2" select="($EAC * $BCWS div $BAC) + ($BAC * (1 - ($BCWS div $BAC)))"/>

                <td align="right" width="{$I_SeparationColWidth}">
                </td>
                <td align="right" width="{$I_ValueColWidth}">
                    <xsl:call-template name="T_CellColor">
                        <xsl:with-param name="STR_Text"><xsl:value-of select="format-number($BAC, $STR_FormatNumber)"/></xsl:with-param>
                    </xsl:call-template>
                </td>
                <td align="right" width="{$I_ValueColWidth}">
                    <xsl:call-template name="T_CellColor">
                        <xsl:with-param name="STR_Text"><xsl:value-of select="format-number($BCWS, $STR_FormatNumber)"/></xsl:with-param>
                    </xsl:call-template>
                </td>
                <td align="right" width="{$I_ValueColWidth}">
                    <xsl:call-template name="T_CellColor">
                        <xsl:with-param name="STR_Text"><xsl:value-of select="format-number($BCWP, $STR_FormatNumber)"/></xsl:with-param>
                    </xsl:call-template>
                </td>
                <td align="right" width="{$I_ValueColWidth}">
                    <xsl:call-template name="T_CellColor">
                        <xsl:with-param name="STR_Text"><xsl:value-of select="format-number($ACWP, $STR_FormatNumber)"/></xsl:with-param>
                    </xsl:call-template>
                </td>
                <td align="right" width="{$I_ValueColWidth}">
                    <xsl:call-template name="T_CellColor">
                        <xsl:with-param name="STR_Text"><xsl:value-of select="format-number($SPI, $STR_FormatNumber)"/></xsl:with-param>
                    </xsl:call-template>
                </td>
                <td align="right" width="{$I_ValueColWidth}">
                    <xsl:call-template name="T_CellColor">
                        <xsl:with-param name="STR_Text"><xsl:value-of select="format-number($CPI, $STR_FormatNumber)"/></xsl:with-param>
                    </xsl:call-template>
                </td>
                <td align="right" width="{$I_ValueColWidth}">
                    <xsl:call-template name="T_CellColor">
                        <xsl:with-param name="STR_Text"><xsl:value-of select="format-number($EAC2, $STR_FormatNumber)"/></xsl:with-param>
                    </xsl:call-template>
                </td>
            </xsl:if>
        </tr>
    </xsl:if>

    <xsl:for-each select="./task">
        <xsl:call-template name="T_Task">
            <xsl:with-param name="STR_TaskId">
                <xsl:if test="$b_TaskNode = 1"><xsl:value-of select="$STR_TaskId"/></xsl:if>
                <xsl:if test="$b_TaskNode = 1"><xsl:text>_</xsl:text></xsl:if>
                <xsl:value-of select="position()"/>
            </xsl:with-param>
            <xsl:with-param name="STR_TaskClass">
                <xsl:choose>
                <xsl:when test="$b_TaskNode = 0"><xsl:text>root_task</xsl:text></xsl:when>
                <xsl:otherwise><xsl:text>child_of_</xsl:text><xsl:value-of select="$STR_TaskId"/></xsl:otherwise>
                </xsl:choose>
            </xsl:with-param>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>

<xsl:template name="T_Images">
    <xsl:param name="B_FinalCall" select="1"/>
    <xsl:param name="STR_TaskId"/>

    <xsl:variable name="xml_This" select="."/>
    <xsl:variable name="b_LastTask" select="count(following-sibling::task) = 0"/>
    <xsl:variable name="b_HasChildren" select="count(./task) &gt; 0"/>

    <!-- Recursive call -->
    <xsl:for-each select="parent::task">
        <xsl:call-template name="T_Images">
            <xsl:with-param name="B_FinalCall" select="0"/>
        </xsl:call-template>
    </xsl:for-each>

    <xsl:if test="$B_FinalCall = 1">
        <!-- Node image -->
        <xsl:if test="$b_HasChildren = 1">
            <img alt="o">
                <xsl:if test="$b_LastTask = 1">
                    <xsl:choose>
                    <xsl:when test="not(parent::task)">
                        <xsl:attribute name="src">ftvtree/ftv2mlastnode.png</xsl:attribute>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:attribute name="src">ftvtree/ftv2plastnode.png</xsl:attribute>
                    </xsl:otherwise>
                    </xsl:choose>
                </xsl:if>
                <xsl:if test="$b_LastTask = 0">
                    <xsl:attribute name="src">ftvtree/ftv2pnode.png</xsl:attribute>
                </xsl:if>
                <xsl:attribute name="onclick">toggleRow('child_of_<xsl:value-of select="$STR_TaskId"/>', this)</xsl:attribute>
            </img>
        </xsl:if>
        <xsl:if test="$b_HasChildren = 0">
            <xsl:if test="$b_LastTask = 0">
                <img alt="+" src="ftvtree/ftv2node.png"/>
            </xsl:if>
            <xsl:if test="$b_LastTask = 1">
                <img alt="+" src="ftvtree/ftv2lastnode.png"/>
            </xsl:if>
        </xsl:if>

        <!-- Item image -->
        <xsl:if test="$b_HasChildren = 1">
            <img alt="[]" src="ftvtree/ftv2folderclosed.png"/>
        </xsl:if>
        <xsl:if test="$b_HasChildren = 0">
            <img alt="[]" src="ftvtree/ftv2doc.png"/>
        </xsl:if>

    </xsl:if>
    <xsl:if test="$B_FinalCall = 0">
        <!-- Offset -->
        <xsl:if test="$b_LastTask = 1">
            <img alt=" " src="ftvtree/ftv2blank.png"/>
        </xsl:if>
        <xsl:if test="$b_LastTask = 0">
            <img alt="|" src="ftvtree/ftv2vertline.png"/>
        </xsl:if>
    </xsl:if>

</xsl:template>

<xsl:template name="T_CellColor">
    <xsl:param name="STR_Text" select="0.00"/>

    <xsl:choose>
    <xsl:when test="number(@reference) &lt; 0">
        <!-- Non-tracking tasks -->
        <font color="{$STR_NoColor}">
        <b><xsl:value-of select="$STR_Text"/></b>
        </font>
    </xsl:when>
    <xsl:otherwise>
        <xsl:param name="D_RefValue" select="number(@reference) + (number(@reference-opportunities) * $D_RiskRatio) - (number(@reference-opportunities) * $D_RiskRatio)"/>
        <xsl:param name="D_CurValue" select="number(@imputed) + number(@remaining) + (number(@remaining-risks) * $D_RiskRatio) - (number(@remaining-opportunities) * $D_RiskRatio)"/>
        <xsl:param name="D_DiffValue" select="$D_RefValue - $D_CurValue"/>

        <xsl:variable name="d_Ratio">
            <xsl:choose>
            <xsl:when test="$D_RefValue=0"><xsl:value-of select="$D_DiffValue"/></xsl:when>
            <xsl:otherwise><xsl:value-of select="$D_DiffValue div $D_RefValue"/></xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:variable name="d_HexRatio">
            <xsl:choose>
            <xsl:when test="$d_Ratio &lt; -1"><xsl:value-of select="1"/></xsl:when>
            <xsl:when test="$d_Ratio &lt; 0"><xsl:value-of select="- $d_Ratio"/></xsl:when>
            <xsl:when test="$d_Ratio &lt; 1"><xsl:value-of select="$d_Ratio"/></xsl:when>
            <xsl:otherwise><xsl:value-of select="1"/></xsl:otherwise>
            </xsl:choose>
        </xsl:variable>

        <xsl:variable name="str_HexOctet">
            <xsl:call-template name="T_Dec2Hex">
                <xsl:with-param name="I_Value" select="(1 - $d_HexRatio) * 255"/>
                <xsl:with-param name="I_MinDigits" select="2"/>
            </xsl:call-template>
        </xsl:variable>

        <xsl:attribute name="bgcolor">
            <xsl:choose>
            <xsl:when test="not(@reference)">
                <xsl:text>#ffffff</xsl:text>
            </xsl:when>
            <xsl:when test="number(@reference) &lt; 0">
                <xsl:value-of select="$STR_NoColor"/>
            </xsl:when>
            <xsl:when test="$d_Ratio &lt; 0">
                <xsl:text>#</xsl:text>
                <xsl:text>ff</xsl:text>
                <xsl:value-of select="$str_HexOctet"/>
                <xsl:value-of select="$str_HexOctet"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:text>#</xsl:text>
                <xsl:value-of select="$str_HexOctet"/>
                <xsl:text>ff</xsl:text>
                <xsl:value-of select="$str_HexOctet"/>
            </xsl:otherwise>
            </xsl:choose>
        </xsl:attribute>
        <xsl:value-of select="$STR_Text"/>
    </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<!--<xsl:template name="T_FgColor">
    <xsl:param name="I_RefValue" select="number(@reference)"/>
    <xsl:param name="I_DiffValue" select="number(@reference - @imputed - @remaining)"/>
    <xsl:param name="STR_Text"/>

    <xsl:variable name="d_Ratio">
        <xsl:choose>
        <xsl:when test="$I_RefValue=0"><xsl:value-of select="$I_DiffValue"/></xsl:when>
        <xsl:otherwise><xsl:value-of select="$I_DiffValue div $I_RefValue"/></xsl:otherwise>
        </xsl:choose>
    </xsl:variable>
    <xsl:variable name="d_HexRatio">
        <xsl:choose>
        <xsl:when test="$d_Ratio &lt; -1"><xsl:value-of select="1"/></xsl:when>
        <xsl:when test="$d_Ratio &lt; 0"><xsl:value-of select="- $d_Ratio"/></xsl:when>
        <xsl:when test="$d_Ratio &lt; 1"><xsl:value-of select="$d_Ratio"/></xsl:when>
        <xsl:otherwise><xsl:value-of select="1"/></xsl:otherwise>
        </xsl:choose>
    </xsl:variable>

    <xsl:variable name="str_HexOctet">
        <xsl:call-template name="T_Dec2Hex">
            <xsl:with-param name="I_Value" select="(1 - $d_HexRatio) * 127"/>
            <xsl:with-param name="I_MinDigits" select="2"/>
        </xsl:call-template>
    </xsl:variable>

    <font>
    <xsl:attribute name="color">
        <xsl:choose>
        <xsl:when test="not(@reference)">
            <xsl:text>#ffffff</xsl:text>
        </xsl:when>
        <xsl:when test="$d_Ratio &lt; 0">
            <xsl:text>#</xsl:text>
            <xsl:text>ff</xsl:text>
            <xsl:value-of select="$str_HexOctet"/>
            <xsl:value-of select="$str_HexOctet"/>
        </xsl:when>
        <xsl:when test="$d_Ratio &gt; 0">
            <xsl:text>#</xsl:text>
            <xsl:value-of select="$str_HexOctet"/>
            <xsl:text>ff</xsl:text>
            <xsl:value-of select="$str_HexOctet"/>
        </xsl:when>
        <xsl:otherwise>
            <xsl:text>#ffffff</xsl:text>
        </xsl:otherwise>
        </xsl:choose>
    </xsl:attribute>
    <b><xsl:value-of select="$STR_Text"/></b>
    </font>
</xsl:template>-->

<xsl:template name="T_Dec2Hex">
    <xsl:param name="I_Value" select="0"/>
    <xsl:param name="I_MinDigits" select="1"/>

    <xsl:variable name="I_UpperDigits" select="floor($I_Value div 16)"/>
    <xsl:variable name="I_LastDigit" select="$I_Value - ($I_UpperDigits * 16)"/>

    <xsl:if test="($I_UpperDigits &gt; 0) or ($I_MinDigits &gt; 1)">
        <xsl:call-template name="T_Dec2Hex">
            <xsl:with-param name="I_Value" select="$I_UpperDigits"/>
            <xsl:with-param name="I_MinDigits" select="$I_MinDigits - 1"/>
        </xsl:call-template>
    </xsl:if>

    <xsl:choose>
    <xsl:when test="$I_LastDigit &lt; 1">0</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 2">1</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 3">2</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 4">3</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 5">4</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 6">5</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 7">6</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 8">7</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 9">8</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 10">9</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 11">a</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 12">b</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 13">c</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 14">d</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 15">e</xsl:when>
    <xsl:when test="$I_LastDigit &lt; 16">f</xsl:when>
    </xsl:choose>
</xsl:template>

</xsl:stylesheet>
