<?xml version="1.0" encoding="iso-8859-1"?>

<!--
    Copyright (c) 2008-2010, Alexis Royer, http://alexis.royer.free.fr/Watch

    All rights reserved.

    Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

        * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
        * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
        * Neither the name of the Watch project nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->

<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" encoding="iso-8859-1" indent="yes"/>

<xsl:param name="STR_Title">
    <xsl:choose>
    <xsl:when test="/watch/@project"><xsl:value-of select="/watch/@project"/></xsl:when>
    <xsl:otherwise><xsl:text>Watch</xsl:text></xsl:otherwise>
    </xsl:choose>
    <xsl:text> </xsl:text>
    <xsl:if test="/watch/@reference">
        <xsl:text>- vs </xsl:text><xsl:value-of select="/watch/@reference"/>
    </xsl:if>
</xsl:param>
<xsl:param name="STR_DataFile" select="'data.txt'"/>
<xsl:param name="B_EVM">
    <xsl:choose>
    <xsl:when test="count(/watch/task/@planned) &gt; 0">1</xsl:when>
    <xsl:otherwise>0</xsl:otherwise>
    </xsl:choose>
</xsl:param>

<xsl:param name="STR_BACTitle" select="'BAC (Budgeted At Completion)'"/>                    <xsl:param name="STR_BACLineColor" select="'red'"/>
<xsl:param name="STR_BCWSTitle" select="'BCWS (Budgeted Cost of Work Scheduled)'"/>         <xsl:param name="STR_BCWSLineColor" select="'#ff9900'"/>
<xsl:param name="STR_ACWPTitle" select="'ACWP (Actual Cost of Work Performed)'"/>           <xsl:param name="STR_ACWPLineColor" select="'blue'"/>
<xsl:param name="STR_BCWPTitle" select="'BCWP (Budgeted Cost of Work Performed)'"/>         <xsl:param name="STR_BCWPLineColor" select="'green'"/>
<xsl:param name="STR_EACTitle" select="'EAC (Estimated At Completion)'"/>                   <xsl:param name="STR_EACLineColor" select="'#aaaaaa'"/>
                                                                                            <xsl:param name="STR_EACFillColor" select="'#efefef'"/>
<xsl:param name="STR_RisksTitle" select="'Risks'"/>                                         <xsl:param name="STR_RisksLineColor" select="'#ffaaaa'"/>
                                                                                            <xsl:param name="STR_RisksFillColor" select="'#ffefef'"/>
<xsl:param name="STR_OpportunitiesTitle" select="'Opportunities'"/>                         <xsl:param name="STR_OpportunitiesLineColor" select="'#aaffaa'"/>
                                                                                            <xsl:param name="STR_OpportunitiesFillColor" select="'#efffef'"/>
<xsl:param name="STR_EACevmTitle" select="'EAC-evm (Estimated At Completion)'"/>            <xsl:param name="STR_EACevmLineColor" select="'purple'"/>


<xsl:template match="/watch">
    <html>
        <head>
            <title><xsl:value-of select="$STR_Title"/></title>
            <style type="text/css">
<xsl:comment>
.directory { font-size: 10pt; font-weight: bold; }
.directory h3 { margin: 0px; margin-top: 1em; font-size: 11pt; }
.directory p { margin: 0px; white-space: nowrap; }
.directory div { display: none; margin: 0px; }
.directory img { vertical-align: middle; }
.directory tr { display: none; margin: 0px; }
.directory a.expand { font-size: 6pt; color: gray; text-decoration: none; text-align: right; }
</xsl:comment>
            </style>
            <script type="text/javascript">
<xsl:comment>
window.console = {};
</xsl:comment>
            </script>
            <script src="static.simile.mit.edu/timeplot/api/1.0/timeplot-api.js?local=true" type="text/javascript"><xsl:text> </xsl:text></script>
            <script type="text/javascript">
<xsl:comment>
var timeplot;

function onLoad() {
    var eventSource = new Timeplot.DefaultEventSource();
    var timeGeometry = new Timeplot.DefaultTimeGeometry({
        gridColor: new Timeplot.Color("#000000"),
        axisLabelsPlacement: "top"
    });
    var valueGeometry = new Timeplot.DefaultValueGeometry({
        gridColor: "#000000",
        axisLabelsPlacement: "left",
        min: 0/*, max: 100*/
    });

    var checkBACDraw = document.getElementById("bac_draw");         var checkBACShowValues = document.getElementById("bac_show_values");
<xsl:if test="$B_EVM = 1">
    var checkBCWSDraw = document.getElementById("bcws_draw");       var checkBCWSShowValues = document.getElementById("bcws_show_values");
</xsl:if>
    var checkACWPDraw = document.getElementById("acwp_draw");       var checkACWPShowValues = document.getElementById("acwp_show_values");
<xsl:if test="$B_EVM = 1">
    var checkBCWPDraw = document.getElementById("bcwp_draw");       var checkBCWPShowValues = document.getElementById("bcwp_show_values");
</xsl:if>
    var checkEACDraw = document.getElementById("eac_draw");         var checkEACShowValues = document.getElementById("eac_show_values");
    var checkRisksDraw = document.getElementById("risks_draw");     var checkRisksShowValues = document.getElementById("risks_show_values");
<xsl:if test="$B_EVM = 1">
    var checkEACEvmDraw = document.getElementById("eac_evm_draw");  var checkEACEvmShowValues = document.getElementById("eac_evm_show_values");
</xsl:if>

    var plotInfo = [];
    var plotInfoIndex = 0;

    if (checkRisksDraw.checked) {
        plotInfo[plotInfoIndex] = Timeplot.createPlotInfo({
            id: "<xsl:value-of select="$STR_RisksTitle"/>",
            dataSource: new Timeplot.ColumnSource(eventSource,4),
            valueGeometry: valueGeometry,
            timeGeometry: timeGeometry,
            lineColor: "<xsl:value-of select="$STR_RisksLineColor"/>",
            fillColor: "<xsl:value-of select="$STR_RisksFillColor"/>",
            showValues: checkRisksShowValues.checked
        });
        plotInfoIndex ++;
    } else {
        checkRisksShowValues.checked = false;
    }

    if (checkEACDraw.checked) {
        var strLineColor = "<xsl:value-of select="$STR_EACLineColor"/>";
        var strFillColor = "<xsl:value-of select="$STR_EACFillColor"/>";
        if (checkRisksDraw.checked) {
            strFillColor = "<xsl:value-of select="$STR_OpportunitiesFillColor"/>";
        }

        plotInfo[plotInfoIndex] = Timeplot.createPlotInfo({
            id: "<xsl:value-of select="$STR_EACTitle"/>",
            dataSource: new Timeplot.ColumnSource(eventSource,3),
            valueGeometry: valueGeometry,
            timeGeometry: timeGeometry,
            lineColor: strLineColor,
            fillColor: strFillColor,
            showValues: checkEACShowValues.checked
        });
        plotInfoIndex ++;
    } else {
        checkEACShowValues.checked = false;
    }

    if (checkRisksDraw.checked) {
        plotInfo[plotInfoIndex] = Timeplot.createPlotInfo({
            id: "<xsl:value-of select="$STR_OpportunitiesTitle"/>",
            dataSource: new Timeplot.ColumnSource(eventSource,5),
            valueGeometry: valueGeometry,
            timeGeometry: timeGeometry,
            lineColor: "<xsl:value-of select="$STR_OpportunitiesLineColor"/>",
            fillColor: "<xsl:value-of select="$STR_EACFillColor"/>",
            showValues: checkRisksShowValues.checked
        });
        plotInfoIndex ++;
    } else {
        checkRisksShowValues.checked = false;
    }

    if (checkBACDraw.checked) {
        plotInfo[plotInfoIndex] = Timeplot.createPlotInfo({
            id: "<xsl:value-of select="$STR_BACTitle"/>",
            dataSource: new Timeplot.ColumnSource(eventSource,1),
            valueGeometry: valueGeometry,
            timeGeometry: timeGeometry,
            lineColor: "<xsl:value-of select="$STR_BACLineColor"/>",
            showValues: checkBACShowValues.checked
        });
        plotInfoIndex ++;
    } else {
        checkBACShowValues.checked = false;
    }

<xsl:if test="$B_EVM = 1">
    if (checkBCWSDraw.checked) {
        plotInfo[plotInfoIndex] = Timeplot.createPlotInfo({
            id: "<xsl:value-of select="$STR_BCWSTitle"/>",
            dataSource: new Timeplot.ColumnSource(eventSource,7),
            valueGeometry: valueGeometry,
            timeGeometry: timeGeometry,
            lineColor: "<xsl:value-of select="$STR_BCWSLineColor"/>",
            showValues: checkBCWSShowValues.checked
        });
        plotInfoIndex ++;
    } else {
        checkBCWSShowValues.checked = false;
    }
</xsl:if>

    if (checkACWPDraw.checked) {
        plotInfo[plotInfoIndex] = Timeplot.createPlotInfo({
            id: "<xsl:value-of select="$STR_ACWPTitle"/>",
            dataSource: new Timeplot.ColumnSource(eventSource,2),
            valueGeometry: valueGeometry,
            timeGeometry: timeGeometry,
            lineColor: "<xsl:value-of select="$STR_ACWPLineColor"/>",
            showValues: checkACWPShowValues.checked
        });
        plotInfoIndex ++;
    } else {
        checkACWPShowValues.checked = false;
    }

<xsl:if test="$B_EVM = 1">
    if (checkBCWPDraw.checked) {
        plotInfo[plotInfoIndex] = Timeplot.createPlotInfo({
            id: "<xsl:value-of select="$STR_BCWPTitle"/>",
            dataSource: new Timeplot.ColumnSource(eventSource,8),
            valueGeometry: valueGeometry,
            timeGeometry: timeGeometry,
            lineColor: "<xsl:value-of select="$STR_BCWPLineColor"/>",
            showValues: checkBCWPShowValues.checked
        });
        plotInfoIndex ++;
    } else {
        checkBCWPShowValues.checked = false;
    }

    if (checkEACEvmDraw.checked) {
        plotInfo[plotInfoIndex] = Timeplot.createPlotInfo({
            id: "<xsl:value-of select="$STR_EACevmTitle"/>",
            dataSource: new Timeplot.ColumnSource(eventSource,12),
            valueGeometry: valueGeometry,
            timeGeometry: timeGeometry,
            lineColor: "<xsl:value-of select="$STR_EACevmLineColor"/>",
            showValues: checkEACEvmShowValues.checked
        });
        plotInfoIndex ++;
    } else {
        checkEACEvmShowValues.checked = false;
    }
</xsl:if>

    var timeplot = Timeplot.create(document.getElementById("timeplot-base"), plotInfo);
    timeplot.loadText("<xsl:value-of select="$STR_DataFile"/>", ",", eventSource);
}

function onClick() {
    onLoad();
}

var resizeTimerID = null;
function onResize() {
    if (resizeTimerID == null) {
        resizeTimerID = window.setTimeout(function() {
            resizeTimerID = null;
            //timeplot.repaint();
            onLoad();
        }, 100);
    }
}
</xsl:comment>
            </script>
        </head>

        <body onload="onLoad();" onresize="onResize();">

            <h1><xsl:value-of select="$STR_Title"/></h1>

            <p>
            <b>User:</b>
                <xsl:choose>
                <xsl:when test="/watch/@user"><xsl:value-of select="/watch/@user"/></xsl:when>
                <xsl:otherwise>Everyone</xsl:otherwise>
                </xsl:choose>
                <br/>
            <b>Reference date:</b>
                <xsl:choose>
                <xsl:when test="/watch/@reference"><xsl:value-of select="/watch/@reference"/></xsl:when>
                <xsl:otherwise>Initial reference</xsl:otherwise>
                </xsl:choose>
                <br/>
            <b>Start date:</b>
                <xsl:choose>
                <xsl:when test="/watch/@start"><xsl:value-of select="/watch/@start"/></xsl:when>
                <xsl:otherwise>None</xsl:otherwise>
                </xsl:choose>
                <br/>
            <b>End date:</b>
                <xsl:choose>
                <xsl:when test="/watch/@end"><xsl:value-of select="/watch/@end"/></xsl:when>
                <xsl:otherwise>None</xsl:otherwise>
                </xsl:choose>
                <br/>
            </p>

            <table>
            <tr><td></td>
                <td><i>Draw</i></td>
                <td><i>Show values</i></td>
                </tr>
            <tr><td align="left"><font color="{$STR_BACLineColor}"><b><xsl:value-of select="$STR_BACTitle"/></b></font></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="bac_draw" checked=""/></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="bac_show_values" checked=""/></td>
                </tr>
<xsl:if test="$B_EVM = 1">
            <tr><td align="left"><font color="{$STR_BCWSLineColor}"><b><xsl:value-of select="$STR_BCWSTitle"/></b></font></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="bcws_draw" checked=""/></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="bcws_show_values"/></td>
                </tr>
</xsl:if>
            <tr><td align="left"><font color="{$STR_ACWPLineColor}"><b><xsl:value-of select="$STR_ACWPTitle"/></b></font></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="acwp_draw" checked=""/></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="acwp_show_values" checked=""/></td>
                </tr>
<xsl:if test="$B_EVM = 1">
            <tr><td align="left"><font color="{$STR_BCWPLineColor}"><b><xsl:value-of select="$STR_BCWPTitle"/></b></font></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="bcwp_draw" checked=""/></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="bcwp_show_values"/></td>
                </tr>
</xsl:if>
            <tr><td align="left"><font color="{$STR_EACLineColor}"><b><xsl:value-of select="$STR_EACTitle"/></b></font></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="eac_draw" checked=""/></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="eac_show_values"/></td>
                </tr>
            <tr><td align="left"><font color="{$STR_RisksLineColor}"><b><xsl:value-of select="$STR_RisksTitle"/></b></font>
                                 <font color="{$STR_EACLineColor}"><b>&amp;</b></font>
                                 <font color="{$STR_OpportunitiesLineColor}"><b><xsl:value-of select="$STR_OpportunitiesTitle"/></b></font></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="risks_draw" checked=""/></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="risks_show_values"/></td>
                </tr>
<xsl:if test="$B_EVM = 1">
            <tr><td align="left"><font color="{$STR_EACevmLineColor}"><b><xsl:value-of select="$STR_EACevmTitle"/></b></font></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="eac_evm_draw" checked=""/></td>
                <td align="center"><input type="checkbox" onclick="onClick()" id="eac_evm_show_values"/></td>
                </tr>
</xsl:if>
            </table>

            <div id="timeplot-base" style="height: 150px;">Timeplot base</div>

        </body>

    </html>
</xsl:template>

</xsl:stylesheet>
