<?xml version="1.0" encoding="iso-8859-1"?>

<!--
    Copyright (c) 2008-2010, Alexis Royer, http://alexis.royer.free.fr/Watch

    All rights reserved.

    Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

        * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
        * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
        * Neither the name of the Watch project nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->

<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="iso-8859-1"/>

<xsl:param name="I_TaskFieldWidth" select="60"/>
<xsl:param name="STR_FormatNumber" select="'0.00'"/>
<xsl:param name="I_ValueFieldWidth" select="10"/>

<xsl:variable name="STR_Endl"><xsl:text>
</xsl:text></xsl:variable>
<xsl:variable name="STR_SeparateField"><xsl:text>----------------------------------------------------------</xsl:text></xsl:variable>

<xsl:variable name="B_AllFields" select="not(count(//@reference) = 0)"/>

<xsl:template match="/watch">
    <xsl:text>== Watch <xsl:value-of select="@project"/> - </xsl:text>
    <xsl:text>user: </xsl:text>
        <xsl:choose>
        <xsl:when test="count(@user) = 1"><xsl:value-of select="@user"/></xsl:when>
        <xsl:otherwise>All</xsl:otherwise>
        </xsl:choose>
    <xsl:text>, start-date: </xsl:text>
        <xsl:choose>
        <xsl:when test="count(@start) = 1"><xsl:value-of select="@start"/></xsl:when>
        <xsl:otherwise>None</xsl:otherwise>
        </xsl:choose>
    <xsl:text>, end-date: </xsl:text>
        <xsl:choose>
        <xsl:when test="count(@end) = 1"><xsl:value-of select="@end"/></xsl:when>
        <xsl:otherwise>None</xsl:otherwise>
        </xsl:choose>
    <xsl:if test="$B_AllFields = 1"><xsl:text>, reference-date: </xsl:text>
        <xsl:choose>
        <xsl:when test="count(@reference) = 1"><xsl:value-of select="@reference"/></xsl:when>
        <xsl:otherwise>None</xsl:otherwise>
        </xsl:choose>
    </xsl:if>
    <xsl:text> ==</xsl:text>
    <xsl:value-of select="$STR_Endl"/>

    <xsl:if test="$B_AllFields = 1">
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text></xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_TaskFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Reference</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Reference</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Reference</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text></xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Remaining</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Remaining</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Remaining</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Final</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Final</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:value-of select="$STR_Endl"/>
    </xsl:if>
    <xsl:call-template name="T_DisplayField">
        <xsl:with-param name="str_Field"><xsl:text>Task</xsl:text></xsl:with-param>
        <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_TaskFieldWidth"/></xsl:with-param>
    </xsl:call-template>
    <xsl:if test="$B_AllFields = 1">
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Value</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Risks</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Opportunities</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
    </xsl:if>
    <xsl:call-template name="T_DisplayField">
        <xsl:with-param name="str_Field"><xsl:text>Imputed</xsl:text></xsl:with-param>
        <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
    </xsl:call-template>
    <xsl:if test="$B_AllFields = 1">
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Value</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Risks</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Opportunities</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Value</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:text>Check</xsl:text></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
    </xsl:if>
    <xsl:value-of select="$STR_Endl"/>

    <xsl:call-template name="T_DisplayField">
        <xsl:with-param name="str_Field"><xsl:value-of select="$STR_SeparateField"/></xsl:with-param>
        <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_TaskFieldWidth"/></xsl:with-param>
    </xsl:call-template>
    <xsl:if test="$B_AllFields = 1">
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:value-of select="$STR_SeparateField"/></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:value-of select="$STR_SeparateField"/></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:value-of select="$STR_SeparateField"/></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
    </xsl:if>
    <xsl:call-template name="T_DisplayField">
        <xsl:with-param name="str_Field"><xsl:value-of select="$STR_SeparateField"/></xsl:with-param>
        <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
    </xsl:call-template>
    <xsl:if test="$B_AllFields = 1">
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:value-of select="$STR_SeparateField"/></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:value-of select="$STR_SeparateField"/></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:value-of select="$STR_SeparateField"/></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:value-of select="$STR_SeparateField"/></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:value-of select="$STR_SeparateField"/></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
        </xsl:call-template>
    </xsl:if>
    <xsl:value-of select="$STR_Endl"/>

    <xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="task">
    <xsl:if test="  (($B_AllFields = 1) and ((@reference &gt; 0) or (@imputed &gt; 0) or (@remaining &gt; 0) or (@risks &gt; 0) or (@opportunities &gt; 0)))
                or  (not($B_AllFields = 1) and (@imputed &gt; 0))">
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field">
                <xsl:call-template name="T_Indentation"/>
                <xsl:choose>
                <xsl:when test="@id"><xsl:value-of select="@id"/></xsl:when>
                <xsl:when test="@date"><xsl:value-of select="@date"/></xsl:when>
                </xsl:choose>
            </xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_TaskFieldWidth"/></xsl:with-param>
        </xsl:call-template>
        <xsl:if test="$B_AllFields = 1">
            <xsl:call-template name="T_DisplayField">
                <xsl:with-param name="str_Field"><xsl:value-of select="format-number(@reference, $STR_FormatNumber)"/></xsl:with-param>
                <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
                <xsl:with-param name="b_LeftAlign" select="0"/>
            </xsl:call-template>
            <xsl:call-template name="T_DisplayField">
                <xsl:with-param name="str_Field"><xsl:value-of select="format-number(@reference-risks, $STR_FormatNumber)"/></xsl:with-param>
                <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
                <xsl:with-param name="b_LeftAlign" select="0"/>
            </xsl:call-template>
            <xsl:call-template name="T_DisplayField">
                <xsl:with-param name="str_Field"><xsl:value-of select="format-number(@reference-opportunities, $STR_FormatNumber)"/></xsl:with-param>
                <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
                <xsl:with-param name="b_LeftAlign" select="0"/>
            </xsl:call-template>
        </xsl:if>
        <xsl:call-template name="T_DisplayField">
            <xsl:with-param name="str_Field"><xsl:value-of select="format-number(@imputed, $STR_FormatNumber)"/></xsl:with-param>
            <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
            <xsl:with-param name="b_LeftAlign" select="0"/>
        </xsl:call-template>
        <xsl:if test="$B_AllFields = 1">
            <xsl:call-template name="T_DisplayField">
                <xsl:with-param name="str_Field"><xsl:value-of select="format-number(@remaining, $STR_FormatNumber)"/></xsl:with-param>
                <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
                <xsl:with-param name="b_LeftAlign" select="0"/>
            </xsl:call-template>
            <xsl:call-template name="T_DisplayField">
                <xsl:with-param name="str_Field"><xsl:value-of select="format-number(@remaining-risks, $STR_FormatNumber)"/></xsl:with-param>
                <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
                <xsl:with-param name="b_LeftAlign" select="0"/>
            </xsl:call-template>
            <xsl:call-template name="T_DisplayField">
                <xsl:with-param name="str_Field"><xsl:value-of select="format-number(@remaining-opportunities, $STR_FormatNumber)"/></xsl:with-param>
                <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
                <xsl:with-param name="b_LeftAlign" select="0"/>
            </xsl:call-template>
            <xsl:call-template name="T_DisplayField">
                <xsl:with-param name="str_Field">
                    <xsl:choose>
                    <xsl:when test="@reference &lt; 0"><xsl:value-of select="format-number(0, $STR_FormatNumber)"/></xsl:when>
                    <xsl:otherwise><xsl:value-of select="format-number(@imputed + @remaining, $STR_FormatNumber)"/></xsl:otherwise>
                    </xsl:choose>
                </xsl:with-param>
                <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
                <xsl:with-param name="b_LeftAlign" select="0"/>
            </xsl:call-template>
            <xsl:call-template name="T_DisplayField">
                <xsl:with-param name="str_Field">
                    <xsl:choose>
                    <xsl:when test="@reference &lt; 0"><xsl:value-of select="format-number(0, $STR_FormatNumber)"/></xsl:when>
                    <xsl:otherwise><xsl:value-of select="format-number(@reference - @imputed - @remaining, $STR_FormatNumber)"/></xsl:otherwise>
                    </xsl:choose>
                </xsl:with-param>
                <xsl:with-param name="i_FieldWidth"><xsl:value-of select="$I_ValueFieldWidth"/></xsl:with-param>
                <xsl:with-param name="b_LeftAlign" select="0"/>
            </xsl:call-template>
        </xsl:if>
        <xsl:value-of select="$STR_Endl"/>
        <xsl:apply-templates select="*"/>
    </xsl:if>
</xsl:template>

<xsl:template name="T_Indentation">
    <xsl:call-template name="T_DisplayBlank">
        <xsl:with-param name="i_BlankCount" select="count(ancestor::task)"/>
    </xsl:call-template>
</xsl:template>

<xsl:template name="T_DisplayBlank">
    <xsl:param name="i_BlankCount" select="0"/>

    <xsl:if test="$i_BlankCount &gt; 0">
        <xsl:text> </xsl:text>
        <xsl:call-template name="T_DisplayBlank">
            <xsl:with-param name="i_BlankCount" select="$i_BlankCount - 1"/>
        </xsl:call-template>
    </xsl:if>
</xsl:template>

<xsl:template name="T_DisplayField">
    <xsl:param name="str_Field"/>
    <xsl:param name="i_FieldWidth"/>
    <xsl:param name="b_LeftAlign" select="1"/>

    <xsl:variable name="str_FieldSubstring" select="substring($str_Field, 0, $i_FieldWidth)"/>
    <xsl:variable name="str_Blank">
        <xsl:call-template name="T_DisplayBlank">
            <xsl:with-param name="i_BlankCount" select="$i_FieldWidth - string-length($str_FieldSubstring) - 1"/>
        </xsl:call-template>
    </xsl:variable>

    <xsl:if test="$b_LeftAlign = 0"><xsl:value-of select="$str_Blank"/></xsl:if>
    <xsl:value-of select="$str_FieldSubstring"/>
    <xsl:if test="not($b_LeftAlign = 0)"><xsl:value-of select="$str_Blank"/></xsl:if>
    <xsl:text> </xsl:text>
</xsl:template>

<!--<xsl:template match="*">
    <xsl:text>&lt;</xsl:text><xsl:value-of select="local-name(.)"/>
        <xsl:for-each select="@*">
            <xsl:text> </xsl:text><xsl:value-of select="local-name(.)"/>
            <xsl:text>="</xsl:text><xsl:value-of select="."/><xsl:text>"</xsl:text>
        </xsl:for-each>
    <xsl:text>&gt;</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>&lt;/</xsl:text><xsl:value-of select="local-name(.)"/><xsl:text>&gt;</xsl:text>
</xsl:template>-->
<xsl:template match="*"/>

</xsl:stylesheet>
